ifneq ($(TARGET_SIMULATOR),true)

LOCAL_PATH:= $(call my-dir)

#############################################  dropbear  ##############################################

include $(CLEAR_VARS)
LOCAL_SRC_FILES:=\
	dbutil.c buffer.c \
	dss.c bignum.c \
	signkey.c rsa.c random.c \
	queue.c \
	atomicio.c compat.c  fake-rfc2553.c
LOCAL_SRC_FILES+=\
	common-session.c packet.c common-algo.c common-kex.c \
	common-channel.c common-chansession.c termcodes.c \
	tcp-accept.c listener.c process-packet.c \
	common-runopts.c circbuffer.c dbpasswd.c
# loginrec.c 
#LOCAL_SRC_FILES+=\
#	cli-algo.c cli-main.c cli-auth.c cli-authpasswd.c cli-kex.c \
#	cli-session.c cli-service.c cli-runopts.c cli-chansession.c \
#	cli-authpubkey.c cli-tcpfwd.c cli-channel.c cli-authinteract.c
LOCAL_SRC_FILES+=\
	svr-kex.c svr-algo.c svr-auth.c sshpty.c \
        svr-authpasswd.c svr-authpubkey.c svr-authpubkeyoptions.c svr-session.c svr-service.c \
        svr-chansession.c svr-runopts.c svr-agentfwd.c svr-main.c svr-x11fwd.c\
        svr-tcpfwd.c svr-authpam.c

LOCAL_SRC_FILES+=netbsd_getpass.c

LOCAL_STATIC_LIBRARIES := libtommath libtomcrypt libz
LOCAL_SHARED_LIBRARIES := libnvram

LOCAL_MODULE_PATH := $(TARGET_OUT_OPTIONAL_EXECUTABLES)
LOCAL_MODULE_TAGS := eng
LOCAL_MODULE := dropbear
LOCAL_C_INCLUDES += $(LOCAL_PATH)/libtommath 
LOCAL_C_INCLUDES += $(LOCAL_PATH)/libtomcrypt/src/headers
LOCAL_C_INCLUDES += $(LOCAL_PATH)/../nvram/nvtool/
LOCAL_CFLAGS += -DDROPBEAR_SERVER -DANDROID_CHANGES

include $(BUILD_EXECUTABLE)

#########################################  dbpasswd   #################################################


#include $(CLEAR_VARS)

#LOCAL_SRC_FILES:=\
	dbpasswd-main.c dbpasswd.c netbsd_getpass.c\
	dbutil.c buffer.c compat.c

#LOCAL_STATIC_LIBRARIES := libtommath libtomcrypt
#LOCAL_MODULE_PATH := $(TARGET_OUT_OPTIONAL_EXECUTABLES)
#LOCAL_MODULE_TAGS := eng
#LOCAL_MODULE := dbpasswd
#LOCAL_C_INCLUDES += $(LOCAL_PATH)/libtommath
#LOCAL_C_INCLUDES += $(LOCAL_PATH)/libtomcrypt/src/headers
#LOCAL_CFLAGS += -DDROPBEAR_CLIENT

#include $(BUILD_EXECUTABLE)

#########################################  guest_main  #####################################################

include $(CLEAR_VARS)

LOCAL_SRC_FILES:=guest_main.c

LOCAL_SHARED_LIBRARIES := libsqlite libcutils	libnvram
LOCAL_MODULE_PATH := $(TARGET_OUT_EXECUTABLES)
LOCAL_MODULE_TAGS := eng
LOCAL_MODULE := guest_main
LOCAL_CFLAGS += -DDROPBEAR_CLIENT
LOCAL_C_INCLUDES += $(LOCAL_PATH)/../nvram/nvtool/

include $(BUILD_EXECUTABLE)

########################################   dropbear_server.sh   ###########################################

#include $(CLEAR_VARS)
#LOCAL_MODULE := dropbear_server.sh
#LOCAL_MODULE_TAGS := eng
#LOCAL_MODULE_CLASS := ETC 
#LOCAL_MODULE_PATH := $(TARGET_OUT_OPTIONAL_EXECUTABLES)
#LOCAL_SRC_FILES := $(LOCAL_MODULE)
#include $(BUILD_PREBUILT)

########################################   copy configure file  ############################################

etc_dir := $(TARGET_OUT)/etc/dropbear
key_dir := $(TARGET_OUT)/root/.ssh

#include $(CLEAR_VARS)
#LOCAL_MODULE := passwd
#LOCAL_MODULE_TAGS := eng
#LOCAL_MODULE_CLASS := ETC
#LOCAL_MODULE_PATH := $(etc_dir)
#LOCAL_SRC_FILES := $(LOCAL_MODULE)
#include $(BUILD_PREBUILT)

include $(CLEAR_VARS)
LOCAL_MODULE := dropbear_rsa_host_key
LOCAL_MODULE_TAGS := eng
LOCAL_MODULE_CLASS := ETC
LOCAL_MODULE_PATH := $(etc_dir)
LOCAL_SRC_FILES := $(LOCAL_MODULE)
include $(BUILD_PREBUILT)

include $(CLEAR_VARS)
LOCAL_MODULE := authorized_keys
LOCAL_MODULE_TAGS := eng
LOCAL_MODULE_CLASS := ETC
LOCAL_MODULE_PATH := $(key_dir)

LOCAL_SRC_FILES := authorized_keys
LOCAL_SRC_FILES := gvc3200_pub_key

include $(BUILD_PREBUILT)


#include $(CLEAR_VARS)
#copy_from := 
#copy_to := $(TARGET_OUT)/root/.ssh/authorized_keys
#copy_from := $(LOCAL_PATH)/,$(copy_from)
#$(copy_to) : PRIVATE_MODULE := system_etcdir
#$(copy_to) : $(TARGET_OUT)/% : $(LOCAL_PATH)/% | $(ACP)
#$(transform-prebuilt-to-target)

#ALL_PREBUILT += $(copy_to)


###########################################################################################################

#include $(CLEAR_VARS)

#LOCAL_SRC_FILES:=\
#	scp.c progressmeter.c atomicio.c scpmisc.c

#LOCAL_STATIC_LIBRARIES := libtommath libtomcrypt

#LOCAL_MODULE_PATH := $(TARGET_OUT_OPTIONAL_EXECUTABLES)

#LOCAL_MODULE_TAGS := debug

#LOCAL_MODULE := scp
#LOCAL_C_INCLUDES += $(LOCAL_PATH)/libtommath 
#LOCAL_C_INCLUDES += $(LOCAL_PATH)/libtomcrypt/src/headers
#LOCAL_CFLAGS += -DDROPBEAR_CLIENT -DPROGRESS_METER

#include $(BUILD_EXECUTABLE)

endif  # TARGET_SIMULATOR != true


include $(call all-makefiles-under,$(LOCAL_PATH))
