#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>
#include <ctype.h>
#include <sys/stat.h>
#include <sys/reboot.h>
#include <sys/socket.h>
#include <cutils/properties.h>
#include <linux/sockios.h>
#include <linux/if.h>
#include <netinet/in.h>
#include <net/route.h>
#include <arpa/inet.h>
#include <sys/wait.h>
#include "sqlite3.h"
#include <dlfcn.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <assert.h>
#include "nvram.h"
//extern char * nvram_get(const char *name);
//extern int nvram_set(const char *name, const char *value);
//extern int nvram_commit(void);

#define UPGRADEBOOT

/*const char help1[] =
"Supported commands:\n"
	"\tconfig	-- Configure the device\n"
	"\tstatus	-- Show device status\n"
	"\tupgrade	-- Upgrade the device\n"
	"\treboot	-- Reboot the device\n"
	"\treset	-- Factory reset\n"
	"\tformat	-- Format user data partition\n"

	"\twifitest  -- Set Wifi to test mode\n"

	"\tbttest	-- Set bluetooth to test mode\n"

	"\tlink	-- Show Ethernet link status\n"
	"\tping	-- Send ICMP ECHO_REQUEST packets to network hosts\n"
	"\ttraceroute	-- Trace the route to HOST\n"
	"\thelp	-- Show this help text\n"
	"\texit	-- Exit this command shell\n";*/
const char help1[] =
"Supported commands:\n"
	"\tconfig	-- Configure the device\n"
	"\tstatus	-- Show device status\n"
	"\tupgrade	-- Upgrade the device\n"
	"\treboot	-- Reboot the device\n"
	"\treset	-- Factory reset(reset data and cache)\n"
	"\tfacreset	-- Factory reset(reset nvram data and cache)\n"	
	"\tformat	-- Format user data partition\n"
	"\tmemtest	-- test memory\n"

	"\tlink	-- Show Ethernet link status\n"
	"\tping	-- Send ICMP ECHO_REQUEST packets to network hosts\n"
	"\ttraceroute	-- Trace the route to HOST\n"
	"\thelp	-- Show this help text\n"
	"\texit	-- Exit this command shell\n";

const char help2[] =
"Supported commands:\n"
	"\tset name value   -- Set a variable\n"
    "\tget name         -- Get a variable\n"
    "\tunset name       -- Unset a variable\n"
    "\tcommit           -- Commit the changes to FLASH\n"
    "\thelp             -- Show this help text\n"
    "\tstatus           -- Display status\n"
    "\texit             -- Exit this command shell\n";


const char help3[] =
"Supported commands:\n"
	"\tset TFTP	   -- Set upgrade protocol to TFTP\n"
	"\tset HTTP	   -- Set upgrade protocol to HTTP\n"
	"\tset HTTPS	   -- Set upgrade protocol to HTTPS\n"
	"\tset server URL	   -- Set upgrade server URL\n"
	"\tcommit		   -- Commit the changes to FLASH\n"
#ifdef UPGRADEBOOT
	"\tupgradeboot	-- Start the upgrade process with boot0 and u-boot upgraded\n"
#endif
	"\tupgrade	   	-- Start the upgrade process\n"
	"\thelp		   -- Show this help text\n"
	"\texit		   -- Exit this command shell\n";

const char network_info[][50] = {
	"\tNetwork Type:   DHCP\n",
	"\tNetwork Type:   Static IP\n",
	"\tNetwork Type:   PPPoE\n",
	"\tNetwork Type:   WIFI\n",
	"\tNetwork Type:   VLAN\n",
	"\tNetwork Type:   VPN\n",
};
#define PRODUCT_INFO_BASEPATH  "/proc/gxvboard/dev_info"
#define PRODUCT_NAME	PRODUCT_INFO_BASEPATH"/dev_id"
#define PRODUCT_VER		PRODUCT_INFO_BASEPATH"/dev_rev"
#define PRODUCT_MAC_ADD	PRODUCT_INFO_BASEPATH"/dev_mac"

#define DFU_PRODUCT_NAME	"GXP"

#define PROC_NETDEV_PATH	"/proc/net/dev"
#define TMP_FILE_PATH	"/system/etc/dropbear/tmp"

/* network info */
#define WAN_DEVICE		"wan_device"
#define VPN_DEVICE		"vpn_device"
#define NETWORK_TYPE	"network_status"
#define PVALUE_VLAN		"51"

#define DHCP_ETH0_STATUS	"dhcp.eth0.result"
#define DHCP_ETH0_SVC	"init.svc.dhcpcd_eth0"
#define DHCP_ETH0_IP	"dhcp.eth0.ipaddress"
#define DHCP_ETH0_GW	"dhcp.eth0.gateway"
#define DHCP_ETH0_MASK	"dhcp.eth0.mask"

#define DHCP_WLAN0_STATUS	"dhcp.wlan0.result"
#define DHCP_WLAN0_SVC	"init.svc.dhcpcd_wlan0"
#define DHCP_WLAN0_IP	"dhcp.wlan0.ipaddress"
#define DHCP_WLAN0_GW	"dhcp.wlan0.gateway"
#define DHCP_WLAN0_MASK	"dhcp.wlan0.mask"

#define PPPOE_STATUS	"pppoe.on"
#define PPPOE_IP		"pppoe.ipaddress"
#define PPPOE_GATEWAY	"pppoe.gateway"
#define PPPOE_MASK		"pppoe.mask"

#define NET_DNS1	"net.dns1"
#define NET_DNS2	"net.dns2"

/* Upgrade and Factory Rest */
//#define NVRAM_UPGRADE_TFTP	"212=0"
//#define NVRAM_UPGRADE_HTTP	"212=1"
#define UPGRADE_CMD_FNAME	"/proc/bootloader_bcd"
#define UPGRADE_CMD			"start provision"
#define FACTORY_RESET_CMD	"fixed_factory_reset 7\n"
#define USER_DATA_RESET_CMD	"fixed_factory_reset 1\n"

#define NET_TYPE_PVALUE		"212"
#define SERVER_PATH_PVALUE	"192"

#define SYSTEM_UPTIME	"/proc/uptime"
#define SYSTEM_LOAD		"/proc/loadavg"
#define SYSTEM_MEMINFO	"/proc/meminfo"

#define NVRAM_SET_PREFIX	"nvram set "
#define NVRAM_GET_PREFIX	"nvram get "
#define NVRAM_UNSET_PREFIX	"nvram unset "

#define UBOOT_PVALUE	"69"
#define KERNEL_PVALUE	"70"
#define RECOVERY_PVALUE	"7033"
#define SYSTEM_PVALUE	"45"

#define PRODUCT_NAME_LENTH	20
#define CMD_LENTH			1024
#define STATUS_INFO_LENTH	PROPERTY_VALUE_MAX
#define NVRAM_VAR_LENTH		100
#define SW_INFO_LENTH		100
#define MEMINFO_SIZE		200
#define PACKETS_INFO_SIZE	400
#define ARG2_LENGTH			1024

#define ETHTOOL_GSET		0x00000001 /* Get settings. */

/* Bluetooth Info */
#define BLUETOOTH_PREPARE_1		"echo 0 > /sys/class/rfkill/rfkill0/state"
#define BLUETOOTH_PREPARE_2		"echo 1 > /sys/class/rfkill/rfkill0/state"
#define BLUETOOTH_PREPARE_3		"brcm_patchram_plus2 --enable_hci --no2bytes --tosleep 200000 --baudrate 115200 --patchram /system/vendor/modules/bcm20710a1.hcd /dev/ttyS2"
#define IS_BLUETOOTH_OPEN		"hciconfig hci0 up > /dev/null"
#define HCI_RESET_CMD		    "hcitool cmd 0x03 0x0003"
#define HCI_WRITE_SCAN_ENABLE	"hcitool cmd 0x03 0x001a 0x3 > /dev/null"
#define HCI_SET_EVENT_FILTER	"hcitool cmd 0x03 0x0005 0x02 0x00 0x02 > /dev/null"
#define HCI_ENABLE_TEST_MODE	"hcitool cmd 0x06 0x0003 > /dev/null"


static int isbtopen = 0;
char local_bd[13] = {0};
#define HCI_READ_LOCAL_BD	"hcitool dev "

#define WL_DOWN         "wl down"
#define WL_BAND_A       "wl band b"
#define WL_MPC_0        "wl mpc 0"
#define WL_NRATE_R      "wl nrate -r 11"
#define WL_RATESET      "wl rateset 11b"
#define WL_COUNTRY_ALL  "wl country ALL"
#define WL_UP           "wl up"
#define WL_CHANNEL      "wl channel 1"
#define WL_TXPWR1       "wl txpwr1 -1"
#define WL_PKTENG_START "wl pkteng_start 00:11:22:33:44:55 tx 30 1024 0"
#define WL_PHY_FORCECAL "wl phy_forcecal 1"
#define WL_OUT          "wl out"
#define WL_FQACURCY     "wl fqacurcy 1"
#define WL_SCAN_SUPPRESS "wl scansuppress 1"
#define WL_BI           "wl bi 65535"
#define WL_COUNTERS     "wl counters"
#define ADMIN_SECURE	1
/*
#define HCI_SET_AFH_CHANNELS_MIN    "hcitool cmd 0x03 0x003f 0x00 0xf0 0x0f 0x00 0xf0 0x00 0xf0 0x00 0xf0 0x00"
#define HCI_SET_AFH_CHANNELS_MID    "hcitool cmd 0x03 0x003f 0xf1 0x1f 0x1f 0x1f 0xf1 0xf1 0xf1 0x1f 0xf1 0x0f"
#define HCI_SET_AFH_CHANNELS_MAX    "hcitool cmd 0x03 0x003f 0xff 0xff 0xff 0xff 0xff 0xff 0xff 0xff 0xff 0x7f"
#define HCI_READ_LOOPBACK_MODE		"hcitool cmd 0x06 0x0001"
#define HCI_WRITE_LOOPBACK_MODE_L	"hcitool cmd 0x06 0x0002 0x01"
#define HCI_WRITE_LOOPBACK_MODE_R	"hcitool cmd 0x06 0x0002 0x02"
#define HCI_INQUIRY_REMOTE_DEVICES	"hcitool cmd 0x01 0x0001 0x33 0x8b 0x9e 0x08 0x00"
#define AMP_TEST_CMD                "hcitool cmd 0x06 0x0009 0x00"
#define AMP_TEST_END_CMD            "hcitool cmd 0x06 0x0008"
#define ENALBE_AMP_RECEIVER_REPORTS "hcitool cmd 0x06 0x0007 0x01 0x0f"
#define HCI_CMD                     ""
*/

static unsigned int loop = 1;
char command[CMD_LENTH];
char product_name[PRODUCT_NAME_LENTH] = "\0";

struct bootloader_message {
    char command[32];
    char status[32];
    char recovery[1024];
};

static const char *const ss_fmt[] = {
	"%n%llu%u%u%u%u%n%n%n%llu%u%u%u%u%u",
	"%llu%llu%u%u%u%u%n%n%llu%llu%u%u%u%u%u",
	"%llu%llu%u%u%u%u%u%u%llu%llu%u%u%u%u%u%u"
};


#ifdef ADMIN_SECURE
static const char *secure_pvalue[] = {"34","406","506","606","1706","1806","2","196","1361","1359","7903","83",
								    "4505","4512","8024","279","280","281","1383","2352","2452","2552","2652",
								    "2752","2852","1594","2967","6714","22022","7830"};
#endif

struct ethtool_cmd {
	__u32	cmd;
	__u32	supported;	/* Features this interface supports */
	__u32	advertising;	/* Features this interface advertises */
	__u16	speed;		/* The forced speed, 10Mb, 100Mb, gigabit */
	__u8	duplex;		/* Duplex, half or full */
	__u8	port;		/* Which connector port */
	__u8	phy_address;
	__u8	transceiver;	/* Which transceiver to use */
	__u8	autoneg;	/* Enable or disable autonegotiation */
	__u8	mdio_support;
	__u32	maxtxpkt;	/* Tx pkts before generating tx int */
	__u32	maxrxpkt;	/* Rx pkts before generating rx int */
	__u16	speed_hi;
	__u8	eth_tp_mdix;
	__u8	reserved2;
	__u32	lp_advertising;	/* Features the link partner advertises */
	__u32	reserved[2];
};

struct user_net_device_stats {
	unsigned long long rx_packets;	/* total packets received       */
	unsigned long long tx_packets;	/* total packets transmitted    */
	unsigned long long rx_bytes;	/* total bytes received         */
	unsigned long long tx_bytes;	/* total bytes transmitted      */
	unsigned long rx_errors;	/* bad packets received         */
	unsigned long tx_errors;	/* packet transmit problems     */
	unsigned long rx_dropped;	/* no space in linux buffers    */
	unsigned long tx_dropped;	/* no space available in linux  */
	unsigned long rx_multicast;	/* multicast packets received   */
	unsigned long rx_compressed;
	unsigned long tx_compressed;
	unsigned long collisions;

	/* detailed rx_errors: */
	unsigned long rx_length_errors;
	unsigned long rx_over_errors;	/* receiver ring buff overflow  */
	unsigned long rx_crc_errors;	/* recved pkt with crc error    */
	unsigned long rx_frame_errors;	/* recv'd frame alignment error */
	unsigned long rx_fifo_errors;	/* recv'r fifo overrun          */
	unsigned long rx_missed_errors;	/* receiver missed packet     */
	/* detailed tx_errors */
	unsigned long tx_aborted_errors;
	unsigned long tx_carrier_errors;
	unsigned long tx_fifo_errors;
	unsigned long tx_heartbeat_errors;
	unsigned long tx_window_errors;
};

inline int is_pppoe(void)
{
	char *str;
	int ret = 0;
	
	str = strdup(nvram_safe_get(NETWORK_TYPE));
	if(NULL == str)
	{
		return ret;
	}
	ret =  !strcmp(str,"PPPoE");

	free(str);

	return ret;
	
//	return !strcmp(nvram_get(NETWORK_TYPE), "PPPoE");
}

inline int is_dhcp_eth0(void)
{
#if 0
	char svc_status[10] = " ";

	if(strcmp(nvram_get(NETWORK_TYPE), "DHCP") != 0)
		return 0;

	property_get(DHCP_ETH0_SVC, svc_status, NULL);

	return !strcmp(svc_status, "running");
#else
	char *str1;
	char *str2;
	int ret = 0;
	
	str1 = strdup(nvram_safe_get(WAN_DEVICE));
	str2 = strdup(nvram_safe_get(NETWORK_TYPE));
	if((str1 == NULL) || (str2 == NULL) || 
		str1[0] == '\0' || str2[0] == '\0')
	{
		return ret;
	}

	ret = (!strcmp(str1,"eth0")) && (!strcmp(str2,"DHCP"));
	free(str1);
	free(str2);
	return ret;	

//	return !strcmp(nvram_get(WAN_DEVICE), "eth0") \
//		&& !strcmp(nvram_get(NETWORK_TYPE), "DHCP");
#endif
}

inline int is_static_eth0(void)
{
	char *str1;
	char *str2;
	int ret = 0;
	
	str1 = strdup(nvram_safe_get(NETWORK_TYPE));
	str2 = strdup(nvram_safe_get(WAN_DEVICE));

	if((str1 == NULL) || (str2 == NULL) || 
		str1[0] == '\0' || str2[0] == '\0')
	{
		return ret;
	}
	ret =  (!strcmp(str1,"Static IP")) && (!strcmp(str2,"eth0"));
	free(str1);
	free(str2);

	return ret;
	
//	return !strcmp(nvram_get(NETWORK_TYPE), "Static IP")\
//		&& !strcmp(nvram_get(WAN_DEVICE), "eth0");
}

inline int is_dhcp_wlan0(void)
{
#if 0
	char svc_status[10] = " ";

	if(strcmp(nvram_get(NETWORK_TYPE), "DHCP") != 0)
		return 0;

	property_get(DHCP_WLAN0_SVC, svc_status, NULL);

	return !strcmp(svc_status, "running");
#else
	char *str1;
	char *str2;
	int ret = 0;
	
	str1 = strdup(nvram_safe_get(WAN_DEVICE));
	str2 = strdup(nvram_safe_get(NETWORK_TYPE));

	if((str1 == NULL) || (str2 == NULL) || 
		str1[0] == '\0' || str2[0] == '\0')
	{
		return ret;
	}
	ret =  (!strcmp(str1,"wlan0")) && (!strcmp(str2,"DHCP"));

	free(str1);
	free(str2);

	return ret;
//	return !strcmp(nvram_get(WAN_DEVICE), "wlan0") \
//		&& !strcmp(nvram_get(NETWORK_TYPE), "DHCP");
#endif
}

inline int is_wlan0(void)
{
	char *str;
	int ret = 0;
	
	str = strdup(nvram_safe_get(WAN_DEVICE));
	if(str == NULL)
	{
		return ret;
	}

	ret =  !strcmp(str,"wlan0");

	free(str);

	return ret;
//	return !strcmp(nvram_get(WAN_DEVICE), "wlan0");
}

/* p51 != 0, indicate using vlan */
inline int is_vlan(void)
{
	char *str;
	int ret = 0;
	
	str = strdup(nvram_safe_get(PVALUE_VLAN));
	if(str == NULL)
	{
		return ret;
	}
	ret =  !!strtol(str,NULL,10);

	free(str);

	return ret;
	
//	return !!strtol(nvram_get(PVALUE_VLAN), NULL, 10);
}

inline int is_vpn(void)
{
	char *str;
	int ret = 0;
	
	str = strdup(nvram_safe_get(VPN_DEVICE));
	if(str == NULL || str[0] != 'p')
	{
		return ret;
	}

	free(str);

	return 1;
}
/************************
 * RET:	0 --- eth0 dhcp	*
 *		1 --- eth0 static	*
 *		2 --- pppoe		*
 *		3 --- wifi		*
 *		4 --- vlan		*
 *		-1 --- unknown	*
 ************************/
int get_network_type(void)
{
	/* check vlan first, because vlan can be based on any type of netdevice below */

	if(is_vlan())
		return 4;
	else if(is_dhcp_eth0())
		return 0;
	else if(is_static_eth0())
		return 1;
	else if(is_pppoe())
		return 2;
	else if(is_wlan0())
		return 3;
	return -1;
}

/* RET: 0  --- success   *
  *	     < 0  --- failed	 *
  * sin: to return gateway ip *
*/
int get_gatewayip(struct sockaddr_in *sin)
{
	char devname[64], flags[16];
	unsigned long d, g, m;
	int flgs, ref, use, metric, mtu, win, ir;
	char *str;

	FILE *fp = fopen("/proc/net/route", "r");
	if (fp == NULL) {
		return -1;
	}

	if (fscanf(fp, "%*[^\n]\n") < 0) { /* Skip the first line. */
		fclose(fp);		   /* Empty or missing line, or read error. */
		return -1;
	}

	while (1) {
		int r;
		r = fscanf(fp, "%63s%lx%lx%X%d%d%d%lx%d%d%d\n",
				   devname, &d, &g, &flgs, &ref, &use, &metric, &m,
				   &mtu, &win, &ir);
		if (is_vpn())
			str = strdup(nvram_safe_get(VPN_DEVICE));
		else
			str = strdup(nvram_safe_get(WAN_DEVICE));
		if(str == NULL)
		{
			fclose(fp);
			return -1;
		}

		if (r != 11) {
			fclose(fp);
			return -1;
		}

//		if (!strcmp(devname, nvram_get(WAN_DEVICE)) && (flgs & (RTF_UP | RTF_GATEWAY))) {
		if (!strcmp(devname, str) && (flgs & (RTF_UP | RTF_GATEWAY))) {

			free(str);
			break;
		}
		free(str);
	}

	sin->sin_family = AF_INET;
	sin->sin_addr.s_addr = g;
	fclose(fp);

	return 0;
}

int get_ipaddr(struct sockaddr_in *sin)
{
	int sock;
	unsigned long gwip;
	struct ifreq ifr;
	char *str;

	sock = socket(AF_INET, SOCK_DGRAM, 0);
	if (sock < 0) {
		perror("socket error");
		return -1;
	}

	str = strdup(nvram_safe_get(WAN_DEVICE));
	if(str == NULL) {
		close(sock);
		return -1;
	}

	strncpy(ifr.ifr_name, str, IFNAMSIZ);
	free(str);
//	strncpy(ifr.ifr_name, nvram_get(WAN_DEVICE), IFNAMSIZ);
	ifr.ifr_name[IFNAMSIZ - 1]   =   0;

	if (ioctl(sock, SIOCGIFADDR, &ifr) < 0) {
		close(sock);
		return -1;
	}

	memcpy(sin, &ifr.ifr_addr, sizeof(*sin));
	close(sock);

	return 0;
}

int get_vpn_ipaddr(struct sockaddr_in *sin)
{
	int sock;
	unsigned long gwip;
	struct ifreq ifr;
	char *str;

	sock = socket(AF_INET, SOCK_DGRAM, 0);
	if (sock < 0) {
		perror("socket error");
		return -1;
	}

	str = strdup(nvram_safe_get(VPN_DEVICE));
	if(str == NULL) {
		close(sock);
		return -1;
	}

	strncpy(ifr.ifr_name, str, IFNAMSIZ);
	free(str);
	ifr.ifr_name[IFNAMSIZ - 1]   =   0;

	if (ioctl(sock, SIOCGIFADDR, &ifr) < 0) {
		close(sock);
		return -1;
	}

	memcpy(sin, &ifr.ifr_addr, sizeof(*sin));
	close(sock);

	return 0;
}

int get_netmask(struct sockaddr_in *sin)
{
	int sock;
	unsigned long gwip;
	struct ifreq ifr;
	char *str;
	sock = socket(AF_INET, SOCK_DGRAM, 0);
	if (sock < 0) {
		perror("socket error");
		return -1;
	}
	str = strdup(nvram_safe_get(WAN_DEVICE));
	
	if(str == NULL)
	{
		close(sock);
		return -1;
	}

	strncpy(ifr.ifr_name, str, IFNAMSIZ);
	free(str);

	ifr.ifr_name[IFNAMSIZ - 1]   =   0;

	if (ioctl(sock, SIOCGIFNETMASK, &ifr) < 0) {
		close(sock);
		return -1;
	}

	memcpy(sin, &ifr.ifr_addr, sizeof(*sin));
	close(sock);

	return 0;
}

void show_dhcp_info(void)
{
	char status_info[STATUS_INFO_LENTH] = "\0";

	memset(status_info, 0, STATUS_INFO_LENTH);
	property_get(DHCP_ETH0_STATUS, status_info, NULL);
	if(strncmp(status_info, "ok", 2) == 0)
	{
		memset(status_info, 0, STATUS_INFO_LENTH);
		property_get(DHCP_ETH0_IP, status_info, NULL);
		printf("\tIP Address: \t%s\n", status_info[0] != '\0'? status_info: "Unknown");

		memset(status_info, 0, STATUS_INFO_LENTH);
		property_get(DHCP_ETH0_GW, status_info,	NULL);
		printf("\tGateway: \t%s\n", status_info[0] != '\0'? status_info: "Unknown");

		memset(status_info, 0, STATUS_INFO_LENTH);
		property_get(DHCP_ETH0_MASK, status_info, NULL);
		printf("\tNetmask: \t%s\n", status_info[0] != '\0'? status_info: "Unknown");

		memset(status_info, 0, STATUS_INFO_LENTH);
		property_get(NET_DNS1, status_info, NULL);
		printf("\tDNS1: \t\t%s\n", status_info[0] != '\0'? status_info: "Unknown");

		memset(status_info, 0, STATUS_INFO_LENTH);
		property_get(NET_DNS2, status_info, NULL);
		printf("\tDNS2: \t\t%s\n", status_info[0] != '\0'? status_info: "Unknown");
	}
}

#if 0
void show_staticip_info(void)
{
	int rc;
	sqlite3 *db;

	char *name_table[4] = {"IP Address:", "Gateway:", "Netmask:", "DNS:    "};
	char net_info[4][20] = {"Unknown", "Unknown", "Unknown", "Unkonwn"};
	rc = sqlite3_open("/data/data/com.android.providers.settings/databases/settings.db", &db);
	if( rc ){
		fprintf(stderr, "Can't open database: %s\n", sqlite3_errmsg(db));
		sqlite3_close(db);
	}

	const char *netval[4] = {"eth_ip", "eth_mask", "eth_route", "eth_dns"};    //\u8fd9\u51e0\u4e2a\u662f\u6570\u636e\u5e93\u91cc\u7684\u5b57\u6bb5\u503c
	char **dbResult;
	int nRow, nColumn, index;
	char *errmsg;
	int si, i, j;
	char *sqlstr = NULL;
	char *resstr = NULL;

	for( si = 0; si < 4; si ++ )
	{
		sqlstr = malloc(64);
		snprintf(sqlstr, 64, "select * from secure where name=\"%s\";", netval[si]);
		rc = sqlite3_get_table ( db, sqlstr , &dbResult, &nRow, &nColumn, &errmsg );
		if( rc == SQLITE_OK )
		{
//			printf("nRow = %d\nnColumn = %d\n", nRow, nColumn);
			index = nColumn;
			for( i = 0; i < nRow ; i++ )
			{
				for( j = 0 ; j < nColumn; j++ )
				{
					if(strcmp(dbResult[j], "value") == 0)
						sprintf(net_info[si], "%s", dbResult[index]);

					++index;
				}
			}
		}
		else
		{
			sqlite3_free(errmsg);
		}
		free(sqlstr);
		sqlite3_free_table ( dbResult );
	}

	for (si = 0; si < 4; si++)
	{
		printf("\t%s\t%s\n", name_table[si], net_info[si]);
	}
	sqlite3_close(db);
}
#endif
void show_pppoe_info(void)
{
	char status_info[STATUS_INFO_LENTH] = "\0";

	memset(status_info, 0, STATUS_INFO_LENTH);
	property_get(PPPOE_STATUS, status_info, NULL);
	if(strncmp(status_info, "1", 1) == 0)
	{
		memset(status_info, 0, STATUS_INFO_LENTH);
		property_get(PPPOE_IP, status_info, NULL);
		printf("\tIP Address: \t%s\n", status_info[0] != '\0'? status_info: "Unknown");

		memset(status_info, 0, STATUS_INFO_LENTH);
		property_get(PPPOE_GATEWAY, status_info, NULL);
		printf("\tGateway: \t%s\n", status_info[0] != '\0'? status_info: "Unknown");

		memset(status_info, 0, STATUS_INFO_LENTH);
		property_get(PPPOE_MASK, status_info, NULL);
		printf("\tNetmask: \t%s\n", status_info[0] != '\0'? status_info: "Unknown");

		memset(status_info, 0, STATUS_INFO_LENTH);
		property_get(NET_DNS1, status_info, NULL);
		printf("\tDNS1: \t\t%s\n", status_info[0] != '\0'? status_info: "Unknown");

		memset(status_info, 0, STATUS_INFO_LENTH);
		property_get(NET_DNS2, status_info, NULL);
		printf("\tDNS2: \t\t%s\n", status_info[0] != '\0'? status_info: "Unknown");
	}

}

#if 0
void show_wifi_info(void)
{
	char status_info[STATUS_INFO_LENTH] = "\0";

	memset(status_info, 0, STATUS_INFO_LENTH);
	property_get(DHCP_WLAN0_STATUS, status_info, NULL);
	if(strncmp(status_info, "ok", 2) == 0)
	{
		memset(status_info, 0, STATUS_INFO_LENTH);
		property_get(DHCP_WLAN0_IP, status_info, NULL);
		printf("\tIP Address: \t%s\n", status_info[0] != '\0'? status_info: "Unknow");

		memset(status_info, 0, STATUS_INFO_LENTH);
		property_get(DHCP_WLAN0_GW, status_info,	NULL);
		printf("\tGateway: \t%s\n", status_info[0] != '\0'? status_info: "Unknow");

		memset(status_info, 0, STATUS_INFO_LENTH);
		property_get(DHCP_WLAN0_MASK, status_info, NULL);
		printf("\tNetmask: \t%s\n", status_info[0] != '\0'? status_info: "Unknow");

		memset(status_info, 0, STATUS_INFO_LENTH);
		property_get(NET_DNS1, status_info, NULL);
		printf("\tDNS1: \t\t%s\n", status_info[0] != '\0'? status_info: "Unknow");

		memset(status_info, 0, STATUS_INFO_LENTH);
		property_get(NET_DNS2, status_info, NULL);
		printf("\tDNS2: \t\t%s\n", status_info[0] != '\0'? status_info: "Unknow");
	}
}
#else
void show_ip_info(void)
{
	struct sockaddr_in sin;
	char status_info[STATUS_INFO_LENTH] = "\0";

	memset(&sin, 0, sizeof(sin));
	printf("\tIP Address: \t%s\n", get_ipaddr(&sin) != 0 ? "Unknown" : inet_ntoa(sin.sin_addr));

	memset(&sin, 0, sizeof(sin));
	printf("\tNetmask: \t%s\n", get_netmask(&sin) != 0 ? "Unknow" : inet_ntoa(sin.sin_addr));

	memset(&sin, 0, sizeof(sin));
	if(is_vpn()) {
		printf("\tVPN Address: \t%s\n", get_vpn_ipaddr(&sin) != 0 ? "Unknow" : inet_ntoa(sin.sin_addr));
	}

	memset(&sin, 0, sizeof(sin));
	printf("\tGateway: \t%s\n", get_gatewayip(&sin) != 0 ? "Unknown" : inet_ntoa(sin.sin_addr));

	memset(status_info, 0, STATUS_INFO_LENTH);
	property_get(NET_DNS1, status_info, NULL);
	printf("\tDNS1: \t\t%s\n", status_info[0] != '\0'? status_info: "Unknow");

	memset(status_info, 0, STATUS_INFO_LENTH);
	property_get(NET_DNS2, status_info, NULL);
	printf("\tDNS2: \t\t%s\n", status_info[0] != '\0'? status_info: "Unknow");
}
#endif

/*
struct network_info
{
	int index;
	char *network_name[5];
	void (*func)(void);
}gs_net[4] = {
	{0, {DHCP_ETH0_IP, DHCP_ETH0_GW, DHCP_ETH0_MASK, NET_DNS1, NET_DNS2}, show_dhcp_info},
	{1, {}}
};
*/

/*func: read "length" from "path" to "buffer"*/
int read_devinfo(const char *path, char *buffer, unsigned int length)
{
	int fd, count;
	if((fd = open(path, O_RDONLY)) < 0)
	{
		perror("open failed");
		return -1;
	}

	count = read(fd, buffer, length);
	if(count < 0)
	{
		perror("read failed");
		return -1;
	}

	if(count > (int)length)
	{
		count = length;
	}
	buffer[count] = '\0';
	close(fd);
	return count;
}

/* show software version (u-boot  kernel  system  recovery )*/
void print_sw_ver(void)
{
//	char buffer[SW_INFO_LENTH];
//	int count;
//	char *ptmp;
//	char *tmp;
	char *pvalue = NULL;

	printf("Sotfware Version:\n");
	pvalue = strdup(nvram_safe_get(UBOOT_PVALUE));
	if(pvalue == NULL)
	{
		return;
	}
//	pvalue = nvram_get(UBOOT_PVALUE);
	printf("\tu-boot:\t\t%s\n", pvalue? pvalue:"Unknow");
	free(pvalue);

	pvalue = strdup(nvram_safe_get(KERNEL_PVALUE));
	
	if(pvalue == NULL)
	{
		return;
	}
//	pvalue = nvram_get(KERNEL_PVALUE);
	printf("\tkernel:\t\t%s\n", pvalue? pvalue:"Unknow");
	free(pvalue);
	
	pvalue = strdup(nvram_safe_get(RECOVERY_PVALUE));

	if(pvalue == NULL)
	{
		return;
	}
//	pvalue = nvram_get(RECOVERY_PVALUE);
	printf("\trecovery:\t%s\n", pvalue? pvalue:"Unknow");
	free(pvalue);
	
	pvalue = strdup(nvram_safe_get(SYSTEM_PVALUE));
	
	if(pvalue == NULL)
	{
		return;
	}
//	pvalue = nvram_get(SYSTEM_PVALUE);
	printf("\tsystem:\t\t%s\n", pvalue? pvalue:"Unknow");
	free(pvalue);
}


struct account_t {
	char account_name[64];
	char sip_user_id[64];
	char registration_status[64];
};

static struct account_t account_pvalue[] = {
	[0] = {
		.account_name = "270",
		.sip_user_id = "35",
		.registration_status = "4921"
	},
#if 0
	[1] = {
		.account_name = "417",
		.sip_user_id = "404",
		.registration_status = "4922"
	},
	[2] = {
		.account_name = "517",
		.sip_user_id = "504",
		.registration_status = "4923"
	},
	[3] = {
		.account_name = "617",
		.sip_user_id = "604",
		.registration_status = "4924"
	},
	[4] = {
		.account_name = "1717",
		.sip_user_id = "1704",
		.registration_status = "4925"},
	[5] = {
		.account_name = "1817",
		.sip_user_id = "1804",
		.registration_status = "4926"
	},
#endif
};

#define ARRAY_SIZE(x) (sizeof(x) / sizeof((x)[0]))

void show_account_info(void)
{
	char buffer[64];
	char *pvalue = NULL;
	int i;

	printf("Account Info:\n");
	for (i = 0; i < ARRAY_SIZE(account_pvalue); i++) {
		pvalue = nvram_get_safe(account_pvalue[i].account_name, buffer, sizeof(buffer));
		printf("\tAccount%d Name:\t\t%s\n", i + 1, pvalue? pvalue:"Unknow");

		pvalue = nvram_get_safe(account_pvalue[i].sip_user_id, buffer, sizeof(buffer));
		printf("\tSIP User ID:\t\t%s\n", pvalue? pvalue:"Unknow");

		pvalue = nvram_get_safe(account_pvalue[i].registration_status, buffer, sizeof(buffer));
		printf("\tRegistration Status:\t%s\n\n", pvalue? pvalue:"Unknow");
	}
}


/* show upgrade server address and net type(TFTP/HTTP/HTTPS)*/
int printf_upgrade_info(void)
{
	char *pvalue = NULL;
//	struct stat buf;
//	int count;
//	unsigned int is_212 = 1;
//	unsigned int is_192 = 1;
//	char status_info[NVRAM_VAR_LENTH];

	pvalue = strdup(nvram_safe_get(NET_TYPE_PVALUE));

	if(pvalue == NULL)
	{
		return -1;
	}
//	pvalue = nvram_get(NET_TYPE_PVALUE);
	if(NULL == pvalue)
	{
		printf("upgrade net type not set, please run \'set TFTP/HTTP/HTTPS\'\n");
	}
	else
	{
		if(pvalue[0] == '0')
			printf("Upgrade protocol: %s\n", "TFTP");
		else if(pvalue[0] == '1')
			printf("Upgrade protocol: %s\n", "HTTP");
		else if(pvalue[0] == '2')
			printf("Upgrade protocol: %s\n", "HTTPS");
	}
	free(pvalue);

	pvalue = strdup(nvram_safe_get(SERVER_PATH_PVALUE));

//	pvalue = nvram_get(SERVER_PATH_PVALUE);
	if(NULL != pvalue)
	{
		printf("Upgrade server URL: %s\n", pvalue);
	}
	else
	{
		printf("upgrade server URL not set, please run \'set server URL\'\n");
	}
	free(pvalue);

	return 0;
}

int parse_link_info(struct ethtool_cmd *ep)
{
	unsigned int speed;

	printf("	Speed: ");
	speed = (ep->speed_hi << 16) | ep->speed;
	if (speed == 0 || speed == (unsigned short)(-1) || speed == (unsigned int)(-1))
		printf("Unknown!\n");
	else
		printf("%uMb/s\n", speed);

	printf("	Duplex: ");
		switch (ep->duplex) {
		case 0:					//DUPLEX_HALF
			printf("Half\n");
			break;
		case 1:					//DUPLEX_FULL
			printf("Full\n");
			break;
		default:
			printf("Unknown! (%i)\n", ep->duplex);
			break;
		};

	printf("	Auto-negotiation: %s\n", (ep->autoneg == 0x0)?"off" : "on");

	return 0;
}

static inline int procnetdev_version(char *buf)
{
	if (strstr(buf, "compressed"))
		return 2;
	if (strstr(buf, "bytes"))
		return 1;
	return 0;
}

static char *get_name(char *name, char *p)
{
	/* Extract <name> from nul-terminated p where p matches
	   <name>: after leading whitespace.
	   If match is not made, set name empty and return unchanged p */
	int namestart = 0, nameend = 0;

	while (isspace(p[namestart]))
		namestart++;
	nameend = namestart;
	while (p[nameend] && p[nameend] != ':' && !isspace(p[nameend]))
		nameend++;
	if (p[nameend] == ':') {
		if ((nameend - namestart) < IFNAMSIZ) {
			memcpy(name, &p[namestart], nameend - namestart);
			name[nameend - namestart] = '\0';
			p = &p[nameend];
		} else {
			/* Interface name too large */
			name[0] = '\0';
		}
	} else {
		/* trailing ':' not found - return empty */
		name[0] = '\0';
	}
	return p + 1;
}

static void get_dev_fields(char *bp, struct user_net_device_stats *stats, int procnetdev_vsn)
{
	sscanf(bp, ss_fmt[procnetdev_vsn],
		   &stats->rx_bytes, /* missing for 0 */
		   &stats->rx_packets,
		   &stats->rx_errors,
		   &stats->rx_dropped,
		   &stats->rx_fifo_errors,
		   &stats->rx_frame_errors,
		   &stats->rx_compressed, /* missing for <= 1 */
		   &stats->rx_multicast, /* missing for <= 1 */
		   &stats->tx_bytes, /* missing for 0 */
		   &stats->tx_packets,
		   &stats->tx_errors,
		   &stats->tx_dropped,
		   &stats->tx_fifo_errors,
		   &stats->collisions,
		   &stats->tx_carrier_errors,
		   &stats->tx_compressed /* missing for <= 1 */
		   );

	if (procnetdev_vsn <= 1) {
		if (procnetdev_vsn == 0) {
			stats->rx_bytes = 0;
			stats->tx_bytes = 0;
		}
		stats->rx_multicast = 0;
		stats->rx_compressed = 0;
		stats->tx_compressed = 0;
	}
}


/* Only check eth0, I will support other net devices further */
int show_packets_info(char *dev_name)
{
	FILE *fh;
	char buf[512];
	int procnetdev_vsn;
	struct user_net_device_stats net_stat;

	memset(&net_stat, 0, sizeof(struct user_net_device_stats));
	if((fh = fopen(PROC_NETDEV_PATH, "r")) == NULL)
	{
		printf("open /proc/net/dev fail\n");
		return -1;
	}
	fgets(buf, sizeof buf, fh);	/* eat line */
	fgets(buf, sizeof buf, fh);

	procnetdev_vsn = procnetdev_version(buf);

	while (fgets(buf, sizeof buf, fh)) {
		char *s, name[128];

		s = get_name(name, buf);
		get_dev_fields(s, &net_stat, procnetdev_vsn);
//		ife->statistics_valid = 1;

		if (dev_name && !strcmp(dev_name, name))
			break;
	}

	printf("\tRX: Bytes %llu, Packets %llu, Error %lu, Dropped %lu, Frame %lu\n",
		net_stat.rx_bytes, /* missing for 0 */
		net_stat.rx_packets,
		net_stat.rx_errors,
		net_stat.rx_dropped,
		net_stat.rx_frame_errors);

	printf("\tTX: Bytes %llu, Packets %llu, Error %lu, Dropped %lu, Collision %lu, Carrier %lu\n",
		net_stat.tx_bytes, /* missing for 0 */
		net_stat.tx_packets,
		net_stat.tx_errors,
		net_stat.tx_dropped,
		net_stat.collisions,
		net_stat.tx_carrier_errors);
	return 0;
}

int get_link_info(int fd, struct ifreq *ifr)
{
	int err;
	int ret = -1;
	struct ethtool_cmd ecmd;

	ecmd.cmd = ETHTOOL_GSET;
	ifr->ifr_data = (caddr_t)&ecmd;
	err = ioctl(fd, SIOCETHTOOL, ifr);
	if (err == 0) {
		err = parse_link_info(&ecmd);
		if (err)
			return err;
//		allfail = 0;
	} else if (errno != EOPNOTSUPP) {
		perror("Cannot get device settings");
		return -1;
	}
	show_packets_info(ifr->ifr_name);

	return 0;
}

#if 0

void show_network_info(void)
{
	printf("NETWORK:\n");
	switch(get_network_type())
	{
		case 0:
			printf("\tNetwork Type:   DHCP\n");
			show_ip_info();
			//show_dhcp_info();
			break;

		case 1:
			printf("\tNetwork Type:	Static IP\n");
			//show_staticip_info();
			show_ip_info();
			break;

		case 2:
			printf("\tNetwork Type:	PPPoE\n");
			//show_pppoe_info();
			show_ip_info();
			break;

		case 3:
			printf("\tNetwork Type:	  WIFI\n");
			//show_wifi_info();
			show_ip_info();
			break;

		default:
			break;
	}
}
#else
void show_network_info(void)
{
	int net_index;

	printf("NETWORK:\n");
	net_index = get_network_type();
	if (net_index >= 0) {
		printf("%s", network_info[net_index]);
		show_ip_info();
	}
}

#endif

static void child(int argc, char *argv[])
{
	char* argv_child[argc + 1];
	memcpy(argv_child, argv, argc * sizeof(char *));
	argv_child[argc] = NULL;

	execvp(argv_child[0], argv_child);
}
static int fork_execvp(int argc, char *argv[])
{
	pid_t pid;
	int status = 0;
	int ret;

	pid = fork();
	if (pid < 0)
		return -1;
	else if (pid == 0)
		child(argc, argv);
	else {
		ret = wait(&status);
		if (ret < 0)
			perror("Command Error");
	}

	return 0;
}

/* product_name[] is specified when entering main()*/
int item1(void)
{
	printf("%s > ", product_name[0] == '\0' ? DFU_PRODUCT_NAME: product_name);
	return 0;
}

int item2(void)
{
	printf("CONFIG > ");
	return 0;
}

int item3(void)
{
	printf("UPGRADE > ");
	return 0;
}

int help1_cmd(void)
{
	printf("%s", help1);
	return 0;
}

int help2_cmd(void)
{
	printf("%s", help2);
	return 0;
}

int help3_cmd(void)
{
	printf("%s", help3);
	return 0;
}

int status1_cmd(void)
{
	int count, i = 0;
	char status_info[STATUS_INFO_LENTH];
	char *tmp = NULL, *meminfo = NULL;

	if((count = read_devinfo(PRODUCT_NAME, status_info, STATUS_INFO_LENTH)) < 0)
	{
		printf("fail\n");
		return -1;
	}

	i = count;
	status_info[count] = '\t';
	if((count = read_devinfo(PRODUCT_VER, &status_info[i+1], STATUS_INFO_LENTH)) < 0)
	{
		printf("fail\n");
		return -1;
	}
	printf("\nProduct Model: %s\n", status_info);

	i = 0;
	if((count = read_devinfo(PRODUCT_MAC_ADD, status_info, STATUS_INFO_LENTH)) < 0)
	{
		printf("fail\n");
		return -1;
	}

	printf("MAC Address: %s\n", status_info);
	show_network_info();
	printf("\n");
	print_sw_ver();
	printf("\n");
	show_account_info();

	i = 0;
	meminfo = (char *)malloc(MEMINFO_SIZE);
	memset(meminfo, 0, MEMINFO_SIZE);
	if((count = read_devinfo(SYSTEM_MEMINFO, meminfo, MEMINFO_SIZE)) < 0)
	{
		printf("fail\n");
		return -1;
	}
	tmp = meminfo;
	while(*tmp)
	{
		if(*tmp == '\n')
		{
			i++;
			if(i == 5)
			{
				*tmp = '\0';
				break;
			}
		}
		tmp++;
	}
	printf("\nMemory Usage:\n%s\n", meminfo);
	free(meminfo);
	meminfo = NULL;

	i = 0;
	if((count = read_devinfo(SYSTEM_UPTIME, status_info, STATUS_INFO_LENTH)) < 0)
	{
		printf("fail\n");
		return -1;
	}
	status_info[count-1] = '\0';
	printf("\nSystem uptime: %s\n", status_info);

	i = 0;
	if((count = read_devinfo(SYSTEM_LOAD, status_info, STATUS_INFO_LENTH)) < 0)
	{
		printf("fail\n");
		return -1;
	}
	status_info[count-1] = '\0';
	printf("System load: %s\n", status_info);
	printf("\n");
	return 0;
}

int status2_cmd(void)
{
	char *argv[] = {"/system/xbin/cat", "/proc/nvram_status"};

	fork_execvp(2, argv);

	return 0;
}
int config_cmd(void)
{
	loop = 2;
//	item2();
	return 0;
}

int upgrade_cmd(void)
{
	char choose;
	char ch;
	char buffer[2048];
	char *pvalue = NULL;
	char *argv[] = {"/system/xbin/prov_ctrl"};

    memset(buffer, 0, 2048);
	if(loop == 1)
	{
		loop = 3;
		printf_upgrade_info();
		return 0;
	}
	printf("You have chosen to upgrade firewares.\nDo you want to continue (y/N)?");
	scanf("%c", &choose);
	scanf("%c", &ch);		//absorb  redundant \n
	if((choose == 'Y') || (choose == 'y'))
	{
		/*check if upgrade has benn enabled*/
//		pvalue = nvram_get("238");
		pvalue = strdup(nvram_safe_get("238"));
		if((NULL == pvalue) ||
			(strcmp(pvalue, "1") == 0))
		{
			nvram_set("238", "0");
		}
		free(pvalue);
		printf("upgrading ...\n");
	//	execl("/system/xbin/prov_ctrl", "prov_ctrl", NULL);
		fork_execvp(1, argv);
		exit(0);
	}
	return 0;
}

#ifdef UPGRADEBOOT
int upgradeboot_cmd(void)
{
	char choose;
	char ch;
	char *pvalue = NULL;
	printf("You have chosen to upgrade firewares with boot0 and u-boot upgraded.\nDo you want to continue (y/N)?");
	scanf("%c", &choose);
	scanf("%c", &ch);		//absorb  redundant \n
	if((choose == 'Y') || (choose == 'y'))
	{
		/*check if upgrade has benn enabled*/
		pvalue = strdup(nvram_safe_get("238"));
		if((NULL == pvalue) || (strcmp(pvalue, "1") == 0))
		{
			nvram_set("238", "0");
		}
		free(pvalue);
		printf("upgrading ...\n");
		nvram_set(":parseboot", "yes");
		system("prov_ctrl");
		exit(0);
	}
	return 0;
}
#endif

int reboot_cmd(void)
{
	char choose;
	char ch;
	char *argv[] = {"/system/bin/reboot"};
	printf("You have chosen to reboot.\nDo you want to continue (y/N)?");
	scanf("%c", &choose);
	scanf("%c", &ch);		//absorb  redundant \n

	if((choose == 'Y') || (choose == 'y'))
	{
		printf("rebooting ...");
		fork_execvp(1, argv);
	}
	return 0;
}

int ping_cmd(void)
{
	char *argv[] = {"/system/xbin/ping", "-c", "10", NULL};
	char address[128];
	sscanf(command, "%*s%s", address);

	argv[3] = address;

	fork_execvp(4, argv);
	return 0;
}

int traceroute_cmd(void)
{
	char *argv[] = {"/system/xbin/traceroute", NULL};
	char address[128];
	sscanf(command, "%*s%s", address);

	argv[1] = address;

	fork_execvp(2, argv);
	return 0;
}

int reset_cmd(void)
{
	char choose;
	char ch;

	printf("You have chosen to do a factory reset.\nDo you want to continue (y/N)?");
	scanf("%c", &choose);
	scanf("%c", &ch);		//absorb  redundant \n

	if((choose == 'Y') || (choose == 'y'))
	{
		printf("Factory Reseting(reset data and cache)\n");
        system("am broadcast -a \"com.base.module.systemmanager.FACTORY_RESET\" --es cmd \"fixed_factory_reset 3\"");
	}
	return 0;
}

int facreset_cmd(void)
{
	char choose;
	char ch;

	printf("You have chosen to do a factory reset.\nDo you want to continue (y/N)?");
	scanf("%c", &choose);
	scanf("%c", &ch);		//absorb  redundant \n

	if((choose == 'Y') || (choose == 'y'))
	{
		printf("Factory Reseting(reset nvram data and cache)\n");
        system("am broadcast -a \"com.base.module.systemmanager.FACTORY_RESET\" --es cmd \"fixed_factory_reset 7\"");
	}
	return 0;
}

int memtest_cmd(void)
{
	char *argv[] = {"/system/xbin/memtester_android", "400M"};

	fork_execvp(2, argv);
	return 0;
}


int format_cmd(void)
{
	char choose;
	char ch;
	char *argv1[] = {"fixed_factory_reset", "1"};
	char *argv2[] = {"/system/bin/reboot"};


	printf("You have chosen to format user data partition.\nDo you want to continue (y/N)?");
	scanf("%c", &choose);
	scanf("%c", &ch);		//absorb  redundant ' \n '

	if((choose == 'Y') || (choose == 'y'))
	{
		printf("formating user data ...\n");
		fork_execvp(2, argv1);

		printf("rebooting ...");
		fork_execvp(1, argv2);
	}
	return 0;
}


void wifi_send_cmd(char *str)
{


	FILE *fp;
	char buf[200] = {0};

        printf("Send command:%s \n", str);
	if((fp = popen(str, "r")) == NULL)  {
		perror("Fail to popen\n");
		exit(1);
	}

	memset(buf, 0, sizeof(buf));
	while(fgets(buf, sizeof(buf), fp) != NULL) {
		printf("%s", buf);
	}
	pclose(fp);
	fp = NULL;
}

void wifi_send_cmd2(char *str)
{
	wifi_send_cmd(str);
        sleep(2);
}

void wifi_subtest_menu(void)
{

	printf("\n*****************************\n");
	printf("1 wl down\n");
	printf("2 wl band b\n");
	printf("3 wl mpc 0\n");
	printf("4 wl nrate -r 11(Set data rate)\n");
	printf("5 wl rateset 11b\n");
	printf("6 wl country ALL\n");
	printf("7 wl up\n");
	printf("8 wl channel 1(Set channel)\n");
	printf("9 wl txpwr1 -1(Set power)\n");
	printf("a wl pkteng_start xx:xx:xx:xx:xx:xx tx 30 1024 0\n");
	printf("b wl phy_forcecal 1\n");
	printf("c wl wl out\n");
	printf("d wl fqacurcy 1\n");
	printf("e wl scansuppress 1\n");
	printf("f wl bi 65535\n");
	printf("g wl counters\n");
	printf("q Menu Exit\n");
	printf("*****************************\n");
}


void wifi_choose_menu(void)
{
	printf("\n*****************************\n");
	//printf("1 step by step test\n");
	printf("1 set and test\n");
	printf("q Menu Exit\n");
	printf("*****************************\n");
}

void wifi_test_interface(void)
{
	printf("\n*****************************\n");
	printf("1 802.11B mode test\n");
	printf("2 802.11G mode test\n");
	printf("3 802.11N mode test\n");
	//printf("4 unmodulation Tx mode test\n");
	//printf("5 continuoust Rx mode test\n");
	printf("q Menu Exit\n");
	printf("*****************************\n");
}

void wifi_cmd_input(const char *sample_cmd, const char *sample_name)
{
	char user_str[100] = {0};

        printf("e.g. Send %s\n", sample_name);
	printf("Input Command : %s\n", sample_cmd);
	printf("Please Input Command :");
	gets(user_str);
	if (strlen(user_str) > 100) {
	printf("Input too many chars!(<100)\n");
		return;
	}
	wifi_send_cmd(user_str);
}



void wifi_cmd_input2(const char *sample_cmd, const char *sample_name,
        const char *abs, const char *para)
{
        int i = 0;
        int r = 0;
        char result[100] = {0};
	char user_str[50] = {0};
	printf("e.g. %s\n", sample_name);
	printf("Command: %sXX,Input: %s, will run command:%s\n", abs, para, sample_cmd);
	printf("Please Input parameter :");
	gets(user_str);
	if (strlen(user_str) > 49) {
		printf("Input too many chars!(<50)\n");
		return;
	}
        for(i = 0; abs[i] != '\0'; i++){
            result[i] = abs[i];
        }
        for(r = 0; user_str[r] != ' ' && user_str[r] != '\n'; r++){
            result[i++] = user_str[r];
        }
        result[i] = '\0';

	wifi_send_cmd2(result);
}

void wifi_set_test(void)
{
	char choose = '0';

	char ch;
        char user_str[100] = {0};
        char channel[20];
	while(1){

                if (choose != '\n') {
			wifi_test_interface();
                        printf("Input test number>");
		}
		scanf("%c", &choose);
		if (choose != '\n') {
			scanf("%c", &ch);//absorb  redundant ' \n '
		}

                if(choose == '1' || choose == '2' || choose == '3' || choose == '4' || choose == '5'){
                   printf("Input channel(e.g.:1(2412MHz);6(2437MHz);11(2462MHz)):\n");
		   scanf("%s", &channel);
                   sprintf(user_str, "wl channel %s", channel);
                }
		switch (choose) {
			case '1'://802.11B
				wifi_send_cmd2("wl down");
				wifi_send_cmd2("wl band b");
				wifi_send_cmd2("wl mpc 0");
				/*wifi_cmd_input2("wl nrate -r 11", "Set data rate", "wl nrate -r ", "11");
				wifi_cmd_input2("wl rateset 11b", "Set data rate", "wl rateset ", "11b");*/
                                wifi_send_cmd2("wl nrate -r 11");
				wifi_send_cmd2("wl rateset 11b");
				wifi_send_cmd2("wl country ALL");
				wifi_send_cmd2("wl up");
				/*wifi_cmd_input2( "wl channel 1", "Set channel", "wl channel ", "1");
				wifi_cmd_input2("wl txpwr1 -1", "Set power", "wl txpwr1 ", "-1");
				wifi_cmd_input("wl pkteng_start 00:11:22:33:44:55 tx 30 1024 0", " run packet engine; usage:\n wl pkteng <xx:xx:xx:xx:xx:xx> <tx|rx> [ipg] [len] [nframes]");*/
                                wifi_send_cmd2(user_str);
				wifi_send_cmd2("wl txpwr1 -1");
				wifi_send_cmd2("wl pkteng_start 00:11:22:33:44:55 tx 30 1024 0");
				wifi_send_cmd2("wl phy_forcecal 1");
				break;
			case '2'://802.11G
				wifi_send_cmd2("wl down");
				wifi_send_cmd2("wl band b");
				wifi_send_cmd2("wl mpc 0");
				/*wifi_cmd_input2("wl nrate -r 54", "Set data rate", "wl nrate -r ", "54");
				wifi_cmd_input2("wl rateset 54b", "Set data rate", "wl rateset ", "54b");*/
				wifi_send_cmd2("wl nrate -r 54");
				wifi_send_cmd2("wl rateset 54b");
				wifi_send_cmd2("wl country ALL");
				wifi_send_cmd2("wl up");
				/*wifi_cmd_input2("wl channel 1", "Set channel", "wl channel ", "1");
				wifi_cmd_input2("wl txpwr1 -1", "Set power", "wl txpwr1 ", "-1");
				wifi_cmd_input("wl pkteng_start 00:11:22:33:44:55 tx 30 1024 0", " run packet engine; usage:\n wl pkteng <xx:xx:xx:xx:xx:xx> <tx|rx> [ipg] [len] [nframes]");*/
                                wifi_send_cmd2(user_str);
				wifi_send_cmd2("wl txpwr1 -1");
				wifi_send_cmd2("wl pkteng_start 00:11:22:33:44:55 tx 30 1024 0");
				wifi_send_cmd2("wl phy_forcecal 1");
				break;
			case '3'://802.11N
				wifi_send_cmd2("wl down");
				//wifi_cmd_input2("wl band b", "Set band: a = 5G, b = 2.4G", "wl band ", "b");
                                wifi_send_cmd2("wl band b");
				wifi_send_cmd2("wl mpc 0");
				//wifi_cmd_input2("wl nrate -m 7", "Set data rate", "wl nrate -m ", "7");
				wifi_send_cmd2("wl nrate -m 7");
				wifi_send_cmd2("wl rateset 54b");
				wifi_send_cmd2("wl country ALL");
				wifi_send_cmd2("wl up");
				/*wifi_cmd_input2("wl channel 1", "Set channel", "wl channel ", "1");
				wifi_cmd_input2("wl txpwr1 -1", "Set power", "wl txpwr1 ", "-1");
				wifi_cmd_input("wl pkteng_start 00:11:22:33:44:55 tx 30 1024 0", " run packet engine; usage:\n wl pkteng <xx:xx:xx:xx:xx:xx> <tx|rx> [ipg] [len] [nframes]");*/
                                wifi_send_cmd2(user_str);
				wifi_send_cmd2("wl txpwr1 -1");
				wifi_send_cmd2("wl pkteng_start 00:11:22:33:44:55 tx 30 1024 0");
				wifi_send_cmd2("wl phy_forcecal 1");
				break;
                        /*case '4'://Tx mode
				//wifi_cmd_input2("wl band b", "Set band: a = 5G, b = 2.4G", "wl band ", "b");
				wifi_send_cmd2("wl band b");
				wifi_send_cmd2("wl out");
				wifi_send_cmd2("wl fqacurcy 1");
				//wifi_cmd_input2("wl fqacurcy 1", "Set channel", "wl fqacurcy ", "1");
				break;
			case '5'://Rx mode
				wifi_send_cmd2("wl down");
				wifi_send_cmd2("wl band auto");
				wifi_send_cmd2("wl mpc 0");
				wifi_send_cmd2("wl country ALL");
				wifi_send_cmd2("wl scansuppress 1");
                                wifi_send_cmd2(user_str);
				//wifi_cmd_input2("wl channel 7", "Set channel", "wl channel ", "7");
				wifi_send_cmd2("wl bi 65535");
				wifi_send_cmd2("wl up");
				wifi_send_cmd2("wl counters");
				break;*/
			case '\n':
			case ' ':
				break;
			case 'q':
				return;
				break;
			default:
				printf("Input error number.Try again\n");
				break;
		}
	}

}
void wifi_subtest(void)
{
	char choose = '0';
	char ch;
        char user_str[100] = {0};
        int way = -1;

        system("mount -o remount,rw /system");
        system("busybox cp /cache/fw_bcm40181a2_mfg.bin /vendor/modules/");
        //system("rmmod bcmdhd");
        system("insmod /vendor/modules/bcmdhd.ko iface_name=wlan0 firmware_path=/vendor/modules/fw_bcm40181a2_mfg.bin nvram_path=/vendor/modules/nvram_ap6210.txt");
        system("ifconfig wlan0 up");
	while(way == -1){
		wifi_choose_menu();
		printf("Input test number>");
		scanf("%c", &choose);
		switch (choose) {
			case '1':
				//way = 1;
                                way = 2;
				break;
			/*case '2':
				way = 2;
				break;*/
			case '\n':
			case ' ':
				break;
			case 'q':
                                property_set("net.wifi.test", "0");
				return;
				break;
			default:
				printf("Input error number.Try again\n");
				break;
		}

		while(way == 1) {
			if (choose != '\n') {
				wifi_subtest_menu();
				printf("Input test number>");
			}
			scanf("%c", &choose);
			if (choose != '\n') {
				scanf("%c", &ch);//absorb  redundant ' \n '
			}
			switch (choose) {
				case '1':
					wifi_send_cmd(WL_DOWN);
					break;
				case '2':
					wifi_cmd_input(WL_BAND_A, "WL_BAND_A");
					break;
				case '3':
					wifi_send_cmd(WL_MPC_0);
					break;
				case '4':
					wifi_cmd_input(WL_NRATE_R, "WL_NRATE_R");
					break;
				case '5':
					wifi_cmd_input(WL_RATESET, "WL_RATESET");
					break;
				case '6':
					wifi_send_cmd(WL_COUNTRY_ALL);
					break;
				case '7':
					wifi_send_cmd(WL_UP);
					break;
				case '8':
					wifi_cmd_input(WL_CHANNEL, "WL_CHANNEL");
					break;
				case '9':
					wifi_cmd_input(WL_TXPWR1, "WL_TXPWR1");
					break;
				case 'a':
					wifi_cmd_input("wl pkteng_start 00:11:22:33:44:55 tx 30 1024 0", " run packet engine; usage:\n wl pkteng <xx:xx:xx:xx:xx:xx> <tx|rx> [ipg] [len] [nframes]");
					break;
				case 'b':
					wifi_cmd_input(WL_PHY_FORCECAL, "WL_PHY_FORCECAL");
					break;
				case 'c':
					wifi_send_cmd(WL_OUT);
					break;
				case 'd':
					wifi_cmd_input(WL_FQACURCY, "WL_FQACURCY");
					break;
				case 'e':
					wifi_send_cmd(WL_SCAN_SUPPRESS);
					break;
				case 'f':
					wifi_send_cmd(WL_BI);
					break;
				case 'g':
					wifi_send_cmd(WL_COUNTERS);
					break;
				case '\n':
				case ' ':
					break;
				case 'q':
					way = -1;//return;
					break;
				default:
					printf("Input error number.Try again\n");
					break;
			}
		}

		while(way == 2){
		     wifi_set_test();
		     way = -1;
		}
	}
}


void btsend_cmd(char *str)
{
	FILE *fp;
	char buf[200] = {0};

	if ((fp = popen(str, "r")) == NULL) {
		perror("Fail to popen\n");
		exit(1);
	}
	memset(buf, 0, 200 * sizeof(char));
	while(fgets(buf, sizeof(buf), fp) != NULL) {
		printf("%s", buf);
	}
        if (strcmp(str, HCI_READ_LOCAL_BD) == 0)
        {
            char *p = NULL;

            p = strstr(buf, ":");
            if (p != NULL) {
		p = p - 2;//get bd
		memset(local_bd, 0, 12 * sizeof(char));
		memcpy(&local_bd[0], p, 2);
		 memcpy(&local_bd[2], (p + 3), 2);
		 memcpy(&local_bd[4], (p + 6), 2);
		 memcpy(&local_bd[6], (p + 9), 2);
		 memcpy(&local_bd[8], (p + 12), 2);
		 memcpy(&local_bd[10], (p + 15), 2);
            } else {
		printf("read local bd failed\n");
            }
        }
	pclose(fp);
	fp = NULL;
}

void btsub_menu_hopping_mode(void)
{
	printf("\n*****************************\n");
	printf("usage:\n");
	printf("Hopping_Mode       Hex value\n");
	printf("79 Channel	   00\n");
	printf("Single Frequency   01\n");
	printf("Fixed pattern	   02\n");
	printf("*****************************\n");
}

void btsub_menu_frequency(void)
{
	printf("\n*****************************\n");
	printf("usage:\n");
	printf("Frequency          Hex value\n");
	printf("0-78(2402-2480)    00-4E\n");
	printf("*****************************\n");
}

void btsub_menu_modulation_type(void)
{
	printf("\n*****************************\n");
	printf("usage:\n");
	printf("Modulation_Type         Hex value\n");
	printf("00000000 bit pattern	01\n");
	printf("11111111 bit pattern	02\n");
	printf("01010101 bit pattern	03\n");
	printf("11110000 bit pattern	09\n");
	printf("PRBS9 pattern           04\n");
	printf("*****************************\n");
}

void btsub_menu_logical_channel(void)
{
	printf("\n*****************************\n");
	printf("usage:\n");
	printf("Logical_Channel    Hex value\n");
	printf("ACL  EDR	       00\n");
	printf("ACL  Basic	       01\n");
	printf("eSCO EDR	       02\n");
	printf("eSCO Basic	       03\n");
	printf("SCO  Basic	       04\n");
	printf("*****************************\n");
}

void btsub_menu_bb_packet_type(void)
{
	printf("\n*****************************\n");
	printf("usage:\n");
	printf("BB_Packet_Type     Hex value\n");
	printf("NULL	           00\n");
	printf("POLL	           01\n");
	printf("FHS	           02\n");
	printf("DM1	           03\n");
	printf("DH1/2-DH1	   04\n");
	printf("HV1	           05\n");
	printf("HV2/2-EV2	   06\n");
	printf("HV3/EV3/3-EV3	   07\n");
	printf("DV/3-DH1	   08\n");
	printf("AUX1/P5		   09\n");
	printf("DM3/2-DH3	   0A\n");
	printf("DH3/3-DH3	   0B\n");
	printf("EV4/2-EV5	   0C\n");
	printf("EV5/3-EV5	   0D\n");
	printf("DM5/2-DH5	   0E\n");
	printf("DH5/3-DH5	   0F\n");
	printf("*****************************\n");
}

void btsub_menu_bb_packet_length(void)
{
	printf("\n*****************************\n");
	printf("usage:\n");
	printf("BB_Packet_Length   Hex value\n");
	printf("10000	           10 27\n");
	printf("20000	           20 4E\n");
	printf("65535	           FF FF\n");
	printf("*****************************\n");
}

void btsub_menu_tx_power(void)
{
	printf("\n*****************************\n");
	printf("usage:\n");
	printf("TX_Power_Level   Hex value\n");
	printf("max	         00\n");
	printf("01-07            01-07\n");
	printf("*****************************\n");
}


void btsub_menu_mode(void)
{
	printf("\n*****************************\n");
	printf("usage:\n");
	printf("Mode                   Hex value\n");
	printf("Unmodulated	       00\n");
	printf("PRBS9                  01\n");
	printf("PRBS15	               02\n");
	printf("All Zeroes	       03\n");
	printf("All Ones               04\n");
	printf("Incrementing Symbols   05\n");
	printf("*****************************\n");
}

void btsub_menu_modulation_type_ex(void)
{
	printf("\n*****************************\n");
	printf("usage:\n");
	printf("Modulation_Type  Hex value\n");
	printf("GFSK	         00\n");
	printf("QPSK	         01\n");
	printf("8PSK	         02\n");
	printf("*****************************\n");
}

void btsub_menu_frequency_encoded(void)
{
	printf("\n*****************************\n");
	printf("usage:\n");
	printf("Frequency_Encoded      Hex value\n");
	printf("0 - 78 (2402 - 2480)   02-50\n");
	printf("*****************************\n");
}

void btsub_menu_report_period(void)
{
	printf("\n*****************************\n");
	printf("usage:\n");
	printf("Report_Period       Hex value\n");
	printf("250                 FA 00\n");
	printf("1000                E8 03\n");
	printf("2000                D0 07\n");
	printf("*****************************\n");
}

void btsubtest_menu(void)
{
	printf("\n*****************************\n");
	printf("1 BT Continuous Tx command(Tx_Test)\n");
	printf("2 BT Continuous Tx command(Set_Tx_Carrier_Frequency_value)\n");
	printf("3 BT Rx Command (Rx_Test)\n");
	printf("4 BT Rx Command (Write_Receive_Only)\n");
	//printf("b User Send Test Command\n");
	printf("q BT Test Exit And BT APK Enable\n");
	printf("*****************************\n");
}

int btapkenable(int enable)
{
	int ret = -1;
    if (enable) {
        ret = system("pm enable com.android.bluetooth");
        if(ret)
        {
            printf("Enable bt failed\n");
            return WEXITSTATUS(ret);
        }
    } else {
        ret = system("pm disable com.android.bluetooth");
        if(ret)
        {
            printf("Disable bt failed\n");
            return WEXITSTATUS(ret);
        }
    }
    return 1;
}

void btsubtest(void)
{
	char choose = '0';
	char ch;
	char user_str[200] = {0};
	//char bd[20] = {0};
	int status;
	//printf("Input remote device bd: xx:xx:xx:xx:xx:xx\n");
	//menset(bd, 0, 20);
	//scanf("%s", bd);

	while(1) {
		if (choose != '\n') {
			btsubtest_menu();
		}
		printf("Input test number>");
		scanf("%c", &choose);
		if (choose != '\n') {
			scanf("%c", &ch);//absorb  redundant ' \n '
		}
        memset(user_str, 0, 100);
		switch (choose) {
			case '1':
                {
                    char hmode[10] = {0};
                    char freq[10] = {0};
                    char mtype[10] = {0};
                    char lchannel[10] = {0};
                    char ptype[10] = {0};
                    char plen[10] = {0};
                    char power[10] = {0};

                    btsub_menu_hopping_mode();
                    printf("Please choose hopping mode(7):");
                    gets(hmode);

                    btsub_menu_frequency();
                    printf("Please choose frequency(6):");
                    gets(freq);

                    btsub_menu_modulation_type();
                    printf("Please choose modulation type(5):");
                    gets(mtype);

                    btsub_menu_logical_channel();
                    printf("Please choose logical channel(4):");
                    gets(lchannel);

                    btsub_menu_bb_packet_type();
                    printf("Please choose bb packet type(3):");
                    gets(ptype);

                    btsub_menu_bb_packet_length();
                    printf("Please choose bb packet length(2):");
                    gets(plen);

                    btsub_menu_tx_power();
                    printf("Please choose tx power level(1):");
                    gets(power);

				sprintf(user_str, "hcitool cmd 0x3f 0x0051 %c%c %c%c %c%c %c%c %c%c %c%c %s %s %s %s %s %s 09 00 %s",
                        local_bd[10], local_bd[11], local_bd[8], local_bd[9], local_bd[6], local_bd[7],
                        local_bd[4], local_bd[5], local_bd[2], local_bd[3], local_bd[0], local_bd[1],
                        hmode, freq, mtype, lchannel, ptype, plen, power);
				btsend_cmd(HCI_RESET_CMD);
                    printf("send str:%s\n", user_str);
				btsend_cmd(user_str);
                }
				break;
			case '2':
                {
                    char freq_encoded[10] = {0};
                    char mode[10] = {0};
                    char mtype[10] = {0};

                    btsub_menu_frequency_encoded();
                    printf("Please choose frequency(3):");
                    gets(freq_encoded);

                    btsub_menu_mode();
                    printf("Please choose mode(2):");
                    gets(mode);

                    btsub_menu_modulation_type_ex();
                    printf("Please choose modulation type(1):");
                    gets(mtype);

                    sprintf(user_str, "hcitool cmd 0x3f 0x0014 00 %s %s %s 09 00 00",
                        freq_encoded, mode, mtype);
                    btsend_cmd(HCI_RESET_CMD);
                    btsend_cmd(user_str);
                }
                break;
            case '3':
                {
                    char rperiod[10] = {0};
                    char freq[10] = {0};
                    char mtype[10] = {0};
                    char lchannel[10] = {0};
                    char ptype[10] = {0};
                    char plen[10] = {0};

                    btsub_menu_report_period();
                    printf("Please choose report period(6):");
                    gets(rperiod);

                    btsub_menu_frequency();
                    printf("Please choose frequency(5):");
                    gets(freq);

                    btsub_menu_modulation_type();
                    printf("Please choose modulation type(4):");
                    gets(mtype);

                    btsub_menu_logical_channel();
                    printf("Please choose logical channel(3):");
                    gets(lchannel);

                    btsub_menu_bb_packet_type();
                    printf("Please choose bb packet type(2):");
                    gets(ptype);

                    btsub_menu_bb_packet_length();
                    printf("Please choose bb packet length(1):");
                    gets(plen);

				sprintf(user_str, "hcitool cmd 0x3f 0x0052 %c%c %c%c %c%c %c%c %c%c %c%c %s %s %s %s %s %s",
                        local_bd[10], local_bd[11], local_bd[8], local_bd[9], local_bd[6], local_bd[7],
                        local_bd[4], local_bd[5], local_bd[2], local_bd[3], local_bd[0], local_bd[1],
                        rperiod, freq, mtype, lchannel, ptype, plen);
				btsend_cmd(HCI_RESET_CMD);
				btsend_cmd(user_str);
                }
                break;
            case '4':
                {
                    char freq[10] = {0};
                    btsub_menu_frequency_encoded();
                    printf("Please choose frequency:");
                    gets(freq);
                    sprintf(user_str, "hcitool cmd 0x3f 0x002b %s", freq);
                    btsend_cmd(HCI_RESET_CMD);
                    btsend_cmd(user_str);
                }
				break;
/*
			case 'b':
				printf("e.g. Send HCI_SET_EVENT_FILTER\n");
				printf("Input Command : hcitool cmd 0x03 0x0005 0x02 0x00 0x02\n");
				printf("Please Input Command :");
				gets(user_str);
				if (strlen(user_str) > 100) {
					printf("Input too many chars!(<100)\n");
					return;
				}
				btsend_cmd(user_str);
				break;
*/
			case '\n':
			case ' ':
				break;
			case 'q':
                isbtopen = 0;
                btsend_cmd(HCI_RESET_CMD);
                btsend_cmd("hciconfig hci0 down");
                btsend_cmd("killall -9 brcm_patchram_plus2");
                btapkenable(1);
				return;
				break;
			default:
				printf("Input error number.Try again\n");
				break;
		}
	}
}

int btprepare(void)
{
	int ret = -1;

    //bluetooth prepare

    ret = system(BLUETOOTH_PREPARE_1);
    if(ret)
    {
        printf("BLUETOOTH_PREPARE_1 failed\n");
        return WEXITSTATUS(ret);
    }

    ret = system(BLUETOOTH_PREPARE_2);
    if(ret)
    {
        printf("BLUETOOTH_PREPARE_2 failed\n");
        return WEXITSTATUS(ret);
    }
    ret = system(BLUETOOTH_PREPARE_3);
    if(ret)
    {
        printf("BLUETOOTH_PREPARE_3 failed\n");
        return WEXITSTATUS(ret);
    }
    return 1;
}

/* Enable bluetooth under test mode */
int bttest_cmd(void)
{
	int ret = -1;
	char choose;
	char ch;

	printf("You have chosen to enable bluetooth under test mode.\nDo you want to continue (Y/N)?");
	scanf("%c", &choose);
	scanf("%c", &ch);		//absorb  redundant ' \n '

	if((choose == 'Y') || (choose == 'y'))
	{
        btapkenable(0);
        if (!isbtopen)
        {
            btprepare();
        }
        ret = system(IS_BLUETOOTH_OPEN);
		if(ret)
		{
			printf("Please make sure rftesttool is in sdcard\n");
            btapkenable(1);
			return WEXITSTATUS(ret);
		}
        isbtopen = 1;
        ret = system(HCI_RESET_CMD);
		if(ret)
		{
			printf("Failed\n");
			return WEXITSTATUS(ret);
		}
		ret = system(HCI_WRITE_SCAN_ENABLE);
		if(ret)
		{
			printf("Failed\n");
			return WEXITSTATUS(ret);
		}
		ret = system(HCI_SET_EVENT_FILTER);
		if(ret)
		{
			printf("Failed\n");
			return WEXITSTATUS(ret);
		}
                btsend_cmd(HCI_READ_LOCAL_BD);
		ret = system(HCI_ENABLE_TEST_MODE);
		if(ret)
		{
			printf("Failed\n");
			return WEXITSTATUS(ret);
		}
		printf("Bluetooth has been in test mode\n");
		btsubtest();
	}
	return 0;
}

int Wifitest_cmd(void)
{
	struct ifreq ifr;
	int fd;
	int ret = -1;

	/* Setup our control structures. */
	memset(&ifr, 0, sizeof(ifr));

	ret = get_network_type();
        strcpy(ifr.ifr_name, "wlan0");

	/* Open control socket. */
	fd = socket(AF_INET, SOCK_DGRAM, 0);
	if (fd < 0) {
		perror("Cannot get control socket");
		return 70;
	}

	get_link_info(fd, &ifr);
	wifi_subtest();
	return 0;
}

/* show speed, duplex, Auto-negotiation, RX  TX packets info*/
int link_cmd(void)
{
	struct ifreq ifr;
	int fd;
	int ret = -1;

	/* Setup our control structures. */
	memset(&ifr, 0, sizeof(ifr));

	ret = get_network_type();
	if (ret == 3)
		strcpy(ifr.ifr_name, "wlan0");
	else if (ret == -1)
		return -1;
	else
		strcpy(ifr.ifr_name, "eth0");

	/* Open control socket. */
	fd = socket(AF_INET, SOCK_DGRAM, 0);
	if (fd < 0) {
		perror("Cannot get control socket");
		return 70;
	}

	get_link_info(fd, &ifr);
	return 0;
}

int exit1_cmd(void)
{
	exit(0);
}
int exit2_cmd(void)
{
	loop = 1;
	return 0;
}

int set_cmd(void)
{
	char *pname = NULL;	// Name of nvram variable
	char *pvalue = NULL;	// Value of nvram variable
	char *invalid = NULL;
	char cmd_name[20];		//
	unsigned int length;
	int print_flag = 0;

	length = strlen(command);

	pname = malloc(length);
	if(NULL == pname)
	{
		printf("malloc failed\n");
		return -1;
	}
	pvalue = malloc(length);
	if(NULL == pvalue)
	{
		printf("malloc failed\n");
		free(pname);
		return -1;
	}
	invalid = malloc(length);
	if(NULL == invalid)
	{
		printf("malloc failed\n");
		free(pname);
		free(pvalue);
	}

//	printf("length = %u\n", length);
	memset(pname, 0, length);
	memset(pvalue, 0, length);
	memset(invalid, 0, length);

	sscanf(command, "%s%s%s%s", cmd_name, pname, pvalue, invalid);
	if(invalid[0] != '\0')
	{
		printf("Invalid CMD\n");
		goto err;
	}

	if(strcmp(pname, "TFTP") == 0)
	{
		nvram_set("212", "0");
		print_flag = 1;
	}
	else if(strcmp(pname, "HTTP") == 0)
	{
		nvram_set("212", "1");
		print_flag = 1;
	}
	else if(strcmp(pname, "HTTPS") == 0)
	{
		nvram_set("212", "2");
		print_flag = 1;
	}
	else if(strcmp(pname, "URL") == 0)
	{
		nvram_set("192", pvalue);
		print_flag = 1;
	}
	else
	{

		if(nvram_set(pname, pvalue) != 0)
		{
			printf("nvram set failed\n");
		}
		else
		{
			printf("Set %s=%s\n", pname, pvalue);
		}
	}

	if(print_flag)
	{
		printf_upgrade_info();
	}

	err:
		memset(invalid, 0, length);
		free(pname);
		free(pvalue);
		free(invalid);
		return 0;
}

/*show nvram value*/
int get_cmd(void)
{
	char *var_name = NULL;
	char *invalid = NULL;
	char *result = NULL;
	char cmd_name[30];
	unsigned int length;
	#ifdef ADMIN_SECURE
	int i = 0;
	int ret = 0;
	int len = 0;
	#endif

	length = strlen(command);
	var_name = malloc(length);
	if(var_name == NULL)
	{
		printf("malloc failed\n");
		return -1;
	}

	invalid = malloc(length);
	if(invalid == NULL)
	{
		printf("malloc failed\n");
		free(var_name);
		return -1;
	}

	memset(var_name, 0, length);
	memset(invalid, 0, length);

	sscanf(command, "%s%s%s", cmd_name, var_name, invalid);

//	printf("Pvalue: %s \nInvalid: %s\n", var_name, invalid);

	if(invalid[0] != '\0')
	{
		printf("Invalid cmd format\n");
		goto err;
	}

//	result = nvram_get(var_name);
	result = strdup(nvram_safe_get(var_name));
	if(NULL != result)
	{
		#ifdef ADMIN_SECURE
		len = sizeof(secure_pvalue)/sizeof(secure_pvalue[0]);
		for(i=0; i<len; i++)
		{	
			if(strncmp(var_name,secure_pvalue[i],strlen(var_name)) == 0)
			{
				ret = 1;
				break;
			}
		}
		
		if(ret)
		{
			printf("%s= \n", var_name);
		}
		else
		#endif
		{
			printf("%s=%s\n", var_name, result);
		}
	}
	free(result);
	err:
	free(var_name);
	free(invalid);
	return 0;

}

int unset_cmd(void)
{
	char var_name_value[NVRAM_VAR_LENTH];
	char *tmp = command;
	char *tmp_var;
	char *argv[] = {"nvram", "unset", NULL};

	memset(var_name_value, 0, NVRAM_VAR_LENTH);

	tmp += strlen("unset");
	if(*tmp == '\0')
	{
		printf("Please check cmd format \n");
		return 0;
	}

	while(*tmp == ' ')
		tmp++;

	if(*tmp == '\0')
	{
		printf("Please check cmd format \n");
		return 0;
	}
	tmp_var = var_name_value;
	while((*tmp != ' ') && (*tmp != '\0'))
	{
		*tmp_var++ = *tmp++;
	}
	if(*tmp == ' ')
	{
		while(*tmp == ' ')
			tmp++;
		if(*tmp != '\0')
		{
			printf("Please check cmd format\n");
			return 0;
		}
	}

	printf("unset %s\n", var_name_value);

	argv[2] = var_name_value;
	fork_execvp(3, argv);
	nvram_commit();
	return 0;
}

int commit_cmd(void)
{
	nvram_commit();
	return 0;
}

int cmd_not_found(char const *cmd)
{
	printf("cmd \'%s\' not found, input \'help\' for more cmd\n",cmd);
	return 0;
}

struct cmd_tbl_t{
	char *name;
	int (*func)(void);
};

struct cmd_tbl_t cmd_tbl1[] = {
		{"help", help1_cmd},
		{"config", config_cmd},
		{"status", status1_cmd},
		{"upgrade", upgrade_cmd},
		{"reboot", reboot_cmd},
		{"reset", reset_cmd},
             {"facreset", facreset_cmd},
		{"format", format_cmd},
		{"memtest", memtest_cmd},

		/*{"wifitest", Wifitest_cmd},

		{"bttest", bttest_cmd},*/

		{"link", link_cmd},
		{"ping", ping_cmd},
		{"traceroute", traceroute_cmd},
		{"exit", exit1_cmd},
		{NULL, NULL}
};

struct cmd_tbl_t cmd_tbl2[] = {
		{"help", help2_cmd},
		{"set", set_cmd},
		{"get", get_cmd},
		{"unset", unset_cmd},
		{"status", status2_cmd},
		{"commit", commit_cmd},
		{"exit", exit2_cmd},
		{NULL, NULL}
};

struct cmd_tbl_t cmd_tbl3[] = {
		{"help", help3_cmd},
		{"set", set_cmd},
#ifdef UPGRADEBOOT
		{"upgradeboot", upgradeboot_cmd},
#endif
		{"upgrade", upgrade_cmd},
		{"commit", commit_cmd},
		{"exit", exit2_cmd},
		{NULL, NULL}
};

int main(void)
{
	char tmp;
	int pos = 0;
	int i;
	int count = -1;
	/*char* p;

	char buf[256];
	char *env = getenv("PATH");
	snprintf(buf, 256, "%s:/cache/", env);
	setenv("PATH", buf, 1);


	memset(buf, 0, 256);
	env = getenv("LD_LIBRARY_PATH");
	snprintf(buf, 256, "%s:/cache/", env);
	setenv("LD_LIBRARY_PATH", buf, 1);
        system("busybox cp /mnt/extsd/rftesttool/* /cache/");
        system("chmod 777  /cache/*");*/
	/* read product name for fuction item1()*/
	memset(product_name, 0, PRODUCT_NAME_LENTH);
	count = read_devinfo(PRODUCT_NAME, product_name, PRODUCT_NAME_LENTH);
	if(count > 0)
		product_name[count - 1] = 0;

	item1();
	memset(command, 0, CMD_LENTH);
        //property_set("net.wifi.test", "1");
	while(1)
	{
		scanf("%c", &tmp);
		if(tmp == '\n')
		{
			pos = 0;
#if 1
		    if(command[0] == '\0')
			{
//				printf("zero_tm: %d\n", zero_tm++);
				if(loop == 1)
					item1();
				else if(loop == 2)
					item2();
				else
					item3();
			}
#endif
			else
			{
				if(loop == 1)
				{
					i = 0;
					while(cmd_tbl1[i].name != NULL)
					{
						if(strncmp(command, cmd_tbl1[i].name, strlen(cmd_tbl1[i].name)) == 0)
						{
							cmd_tbl1[i].func();
							break;
						}
						i++;
					}
					if(cmd_tbl1[i].name == NULL)
					{
						cmd_not_found(command);
						item1();
					}
					else if(strncmp(cmd_tbl1[i].name, "config", 6) == 0) // do nothing, but it's necessary
					{
						item2();
					}
					else if(strncmp(cmd_tbl1[i].name, "upgrade", 7) == 0) // do nothing, but it's necessary
					{
						item3();
					}
					else
						item1();
				}
				else if(loop == 2)
				{

					i = 0;
					while(cmd_tbl2[i].name != NULL)
					{
						if(strncmp(command, cmd_tbl2[i].name, strlen(cmd_tbl2[i].name)) == 0)
						{
							cmd_tbl2[i].func();
							break;
						}
						i++;
					}
					if(cmd_tbl2[i].name == NULL)
					{
						cmd_not_found(command);
						item2();
					}
					else if(strncmp(cmd_tbl2[i].name, "exit", 4) == 0) // do nothing, but it's necessary
					{
						item1();
					}
					else
						item2();
				}
				else
				{
					i = 0;
					while(cmd_tbl3[i].name != NULL)
					{
						if(strncmp(command, cmd_tbl3[i].name, strlen(cmd_tbl3[i].name)) == 0)
						{
							cmd_tbl3[i].func();
							break;
						}
						i++;
					}
					if(cmd_tbl3[i].name == NULL)
					{
						cmd_not_found(command);
						item3();
					}
					else if(strncmp(cmd_tbl3[i].name, "exit", 4) == 0) // do nothing, but it's necessary
					{
						item1();
					}
					else
						item3();
				}
				memset(command, '\0', CMD_LENTH);
			}
		}
		else
		{
			if(tmp == ' ')
				if(command[0] == '\0')
					continue;
			command[pos++] = tmp;
		}
	}
	return 0;
}
