#!/system/xbin/sh

DEV_ETH="eth0"
DEV_WLAN="wlan0"
BASED_DEV="net.based.dev"
WLAN_PPPOE_USER="net.wlan.pppoe.user"
WLAN_PPPOE_PW="net.wlan.pppoe.pw"
WLAN_NET_TYPE="net.wlan.type"
BASED_DEV_VAL=`getprop $BASED_DEV`
VLAN_DEV_VAL=`getprop net.vlan.dev`

if [ -n $BASED_DEV_VAL -a "$BASED_DEV_VAL" = "$DEV_ETH" ]; then
        PPPOE_USER=`nvram get 82`
        PPPOE_PASSWD=`nvram get 83`
        PPPOE_SERVER_NAME=`nvram get 269`
        PPPOE_NET_TYPE=`nvram get 8`
else
    if [ -n $BASED_DEV_VAL -a "$BASED_DEV_VAL" = "$DEV_WLAN" ]; then
                PPPOE_USER=`getprop $WLAN_PPPOE_USER`
                PPPOE_PASSWD=`getprop $WLAN_PPPOE_PW`
                PPPOE_NET_TYPE=`getprop $WLAN_NET_TYPE`            
#                echo "user: $PPPOE_USER" >> /tmp/pppoe.log         
#                echo "password: $PPPOE_PASSWD" >> /tmp/pppoe.log   
#                echo "net type : $PPPOE_NET_TYPE" >> /tmp/pppoe.log
#                echo "dev: $BASED_DEV_VAL" >> /tmp/pppoe.log

    fi
fi


PPPOE_ARGS="noipdefault noauth default-asyncmap defaultroute hide-password nodetach usepeerdns mtu 1492 mru 1492 noaccomp nodeflate  nopcomp novj novjccomp lcp-echo-interval 2 lcp-echo-failure 10"  

if [ ! -z $PPPOE_SERVER_NAME ];	then
	PPPOE_SERVER_OPT="-S $PPPOE_SERVER_NAME"
else
	PPPOE_SERVER_OPT=""
fi


if [ -z $BASED_DEV_VAL ]; then
    echo "based dev was not set" >> /tmp/pppoe.log
fi

DEV=$VLAN_DEV_VAL
if [ -z $DEV ]; then
   DEV=$BASED_DEV_VAL
fi 

killall -9 pppd 2>/dev/null
wait_boot() {
    COMPLETED=`getprop "sys.boot_completed"`
    while [ -z "$COMPLETED" ] || [ $COMPLETED != 1 ]     
    do 
        sleep 1
        COMPLETED=`getprop "sys.boot_completed"`
    done
}

if [ ! -z $PPPOE_USER ] && [ ! -z $PPPOE_PASSWD ]; then
	if [ $PPPOE_NET_TYPE = '2' ] && [ ! -z $DEV ]; then
        echo "pppd starting...." >> /tmp/pppoe.log
        wait_boot
	    ifconfig $DEV 0.0.0.0

        while :
        do 
            pppd unit 10 pty "pppoe -I $DEV -T 80 -U $DEBUG $PPPOE_SERVER_OPT" \
		    $PPPOE_ARGS user $PPPOE_USER password $PPPOE_PASSWD 
	        sleep 5
            echo "pppd restart" >> /tmp/pppoe.log
        done
	fi
else
	echo "Please Set User and Password" >> /tmp/pppoe.log
fi 
