LOCAL_PATH := $(call my-dir)

L_CFLAGS += -DVERSION=\"1.2.8\" -DNEW_IWLIB=1 -DOPENSSL_NO_ENGINE=1 -DYYTEXT_POINTER=1 -DSTDC_HEADERS=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_MEMORY_H=1 -DHAVE_STRINGS_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_UNISTD_H=1 -DLILENDIAN=1 -DNO_PWD_RESET=1 -DOPENSSL_NO_KRB5=1 -DLINUX=1 -DHAVE_SYS_SOCKET_H=1 -DHAVE_LIBCRYPTO=1 -DHAVE_LIBSSL=1 -DLINUX_FRAMER=1

INCLUDES = $(LOCAL_PATH)
INCLUDES += $(LOCAL_PATH)/src
INCLUDES += $(LOCAL_PATH)/src/eap_types
INCLUDES += $(LOCAL_PATH)/src/eap_types/aka
INCLUDES += $(LOCAL_PATH)/src/eap_types/leap
INCLUDES += $(LOCAL_PATH)/src/eap_types/md5
INCLUDES += $(LOCAL_PATH)/src/eap_types/mschapv2
INCLUDES += $(LOCAL_PATH)/src/eap_types/otp
INCLUDES += $(LOCAL_PATH)/src/eap_types/peap
INCLUDES += $(LOCAL_PATH)/src/eap_types/sim
INCLUDES += $(LOCAL_PATH)/src/eap_types/tls
INCLUDES += $(LOCAL_PATH)/src/eap_types/tnc
INCLUDES += $(LOCAL_PATH)/src/eap_types/ttls
INCLUDES += $(LOCAL_PATH)/src/cardif
INCLUDES += $(LOCAL_PATH)/src/cardif/linux
INCLUDES += $(LOCAL_PATH)/lib
INCLUDES += $(LOCAL_PATH)/lib/libxsupconfig
INCLUDES += $(LOCAL_PATH)/lib/libxsupconfcheck
INCLUDES += $(LOCAL_PATH)/lib/libxsupconfwrite
INCLUDES += $(LOCAL_PATH)/../wireless_tools.30.rtl
INCLUDES += external/openssl/include
INCLUDES += external/libxml2/include
INCLUDES += external/icu4c/common

OBJS = src/backend_sm.c
OBJS += src/config_ssid.c
OBJS += src/profile.c
OBJS += src/eapol.c
OBJS += src/eapol_key_type1.c
OBJS += src/eapol_key_type2.c
OBJS += src/eapol_key_type254.c
OBJS += src/eap.c
OBJS += src/event_core.c
OBJS += src/ipc_callout.c
OBJS += src/key_statemachine.c
OBJS += src/mic.c
OBJS += src/psk.c
OBJS += src/snmp.c
OBJS += src/statemachine.c
OBJS += src/timer.c
OBJS += src/wireless_sm.c
OBJS += src/wpa2.c
OBJS += src/wpa.c
OBJS += src/wpa_common.c
OBJS += src/xsup_common.c
OBJS += src/xsup_debug.c
OBJS += src/xsup_driver.c
OBJS += src/xsup_ipc.c
OBJS += src/eap_types/md5/eapmd5.c
OBJS += src/eap_types/mschapv2/eapmschapv2.c
OBJS += src/eap_types/mschapv2/mschapv2.c
OBJS += src/eap_types/tls/eaptls.c
OBJS += src/eap_types/tls/tls_funcs.c
OBJS += src/eap_types/tls/tls_crypt.c
OBJS += src/eap_types/ttls/eapttls.c
OBJS += src/eap_types/ttls/ttlsphase2.c
OBJS += src/eap_types/otp/eapotp.c
OBJS += src/eap_types/tnc/eaptnc.c
OBJS += src/eap_types/peap/eappeap.c
OBJS += src/eap_types/peap/peap_phase2.c
OBJS += src/eap_types/leap/eapleap.c
OBJS += src/eap_types/leap/leapmd4.c
OBJS += src/eap_types/sim/eapsim.c
OBJS += src/eap_types/sim/fips.c
OBJS += src/eap_types/sim/sha1.c
OBJS += src/eap_types/sim/sim.c
OBJS += src/eap_types/sim/simd11.c
OBJS += src/eap_types/sim/simd5.c
OBJS += src/eap_types/sim/sm_handler.c
OBJS += src/eap_types/aka/eapaka.c
OBJS += src/eap_types/aka/aka.c
OBJS += src/cardif/linux/cardif_linux_wext.c
OBJS += src/cardif/linux/cardif_linux.c
OBJS += src/cardif/linux/cardif_linux_rtnetlink.c
OBJS += src/cardif/linux/cardif_atmel_driver.c
OBJS += src/cardif/generic/cardif_generic.c
OBJS += src/cardif/freebsd/cardif_freebsd.c
########################
include $(CLEAR_VARS)
LOCAL_MODULE := md5-example.conf
LOCAL_MODULE_TAGS := eng
LOCAL_MODULE_CLASS := ETC
LOCAL_MODULE_PATH := $(TARGET_OUT)/etc
LOCAL_SRC_FILES := etc/md5-example.conf
include $(BUILD_PREBUILT)
#########################
include $(CLEAR_VARS)
LOCAL_MODULE := tls-example.conf
LOCAL_MODULE_TAGS := eng
LOCAL_MODULE_CLASS := ETC
LOCAL_MODULE_PATH := $(TARGET_OUT)/etc
LOCAL_SRC_FILES := etc/tls-example.conf
include $(BUILD_PREBUILT)
########################
include $(CLEAR_VARS)
LOCAL_MODULE := peap-example.conf
LOCAL_MODULE_TAGS := eng
LOCAL_MODULE_CLASS := ETC
LOCAL_MODULE_PATH := $(TARGET_OUT)/etc
LOCAL_SRC_FILES := etc/peap-example.conf
include $(BUILD_PREBUILT)
########################
include $(CLEAR_VARS)
LOCAL_MODULE := xsupplicant.sh
LOCAL_MODULE_TAGS := eng
LOCAL_MODULE_CLASS := ETC
LOCAL_MODULE_PATH := $(TARGET_OUT_OPTIONAL_EXECUTABLES)
LOCAL_SRC_FILES := etc/S02Dot1x.sh
include $(BUILD_PREBUILT)

##########################
include $(CLEAR_VARS)
LOCAL_MODULE := libxsupconfig
LOCAL_MODULE_TAGS := eng
LOCAL_CFLAGS := $(L_CFLAGS)
LOCAL_C_INCLUDES := $(INCLUDES)
LOCAL_SRC_FILES :=\
	lib/libxsupconfig/xsupconfig.c\
	lib/libxsupconfig/config_lexicon.c\
	lib/libxsupconfig/config_grammar.c
include $(BUILD_STATIC_LIBRARY)
########################
include $(CLEAR_VARS)
LOCAL_MODULE := libxsupconfcheck
LOCAL_MODULE_TAGS := eng
LOCAL_CFLAGS := $(L_CFLAGS)
LOCAL_C_INCLUDES := $(INCLUDES)
LOCAL_SRC_FILES := lib/libxsupconfcheck/xsupconfcheck.c
include $(BUILD_STATIC_LIBRARY)
########################
include $(CLEAR_VARS)
LOCAL_MODULE := libxsupconfwrite
LOCAL_MODULE_TAGS := eng
LOCAL_CFLAGS := $(L_CFLAGS)
LOCAL_C_INCLUDES := $(INCLUDES)
LOCAL_SRC_FILES := lib/libxsupconfwrite/xsupconfwrite.c
include $(BUILD_STATIC_LIBRARY)
########################
include $(CLEAR_VARS)
LOCAL_MODULE := xsupplicant
LOCAL_MODULE_TAGS := eng
LOCAL_STATIC_LIBRARIES :=\
	libxsupconfig\
	libxsupconfwrite\
	libxsupconfcheck\
	libiw
LOCAL_SHARED_LIBRARIES :=\
	libssl\
	libc\
	libcrypto\
	libm
LOCAL_CFLAGS := $(L_CFLAGS)
LOCAL_SRC_FILES := $(OBJS)
LOCAL_C_INCLUDES := $(INCLUDES)
include $(BUILD_EXECUTABLE)
